﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Reflection;
using System.Reflection.Emit;
using NWScript;
using NWScript.ManagedInterfaceLayer.NWScriptManagedInterface;

using NWEffect = NWScript.NWScriptEngineStructure0;
using NWEvent = NWScript.NWScriptEngineStructure1;
using NWLocation = NWScript.NWScriptEngineStructure2;
using NWTalent = NWScript.NWScriptEngineStructure3;
using NWItemProperty = NWScript.NWScriptEngineStructure4;

namespace CLRScriptFramework
{

    /// <summary>
    /// This partial implementation of the sample script includes wrappers for
    /// the high level NWScript functions.  You should include the wrappers in
    /// your script object type.
    /// </summary>
    public partial class CLRScriptBase
    {
        //
        // Begin action service handler wrappers (autogenerated).
        //

        public Int32 Random(Int32 nMaxInteger)
        {
            return ScriptHost.ExecuteActionService_0_1_Random(nMaxInteger);
        }

        public void PrintString(String sString)
        {
            ScriptHost.ExecuteActionService_1_1_PrintString(sString);
        }

        public void PrintFloat(float fFloat, Int32 nWidth, Int32 nDecimals)
        {
            ScriptHost.ExecuteActionService_2_3_PrintFloat((Single)fFloat, nWidth, nDecimals);
        }

        public String FloatToString(float fFloat, Int32 nWidth, Int32 nDecimals)
        {
            return ScriptHost.ExecuteActionService_3_3_FloatToString((Single)fFloat, nWidth, nDecimals);
        }

        public void PrintInteger(Int32 nInteger)
        {
            ScriptHost.ExecuteActionService_4_1_PrintInteger(nInteger);
        }

        public void PrintObject(UInt32 oObject)
        {
            ScriptHost.ExecuteActionService_5_1_PrintObject(oObject);
        }

        public void AssignCommand(UInt32 oActionSubject, NWAction aActionToAssign)
        {
            InternalSaveStateForAction(aActionToAssign);
            ScriptHost.ExecuteActionService_6_1_AssignCommand(oActionSubject);
        }

        public void DelayCommand(float fSeconds, NWAction aActionToDelay)
        {
            InternalSaveStateForAction(aActionToDelay);
            ScriptHost.ExecuteActionService_7_1_DelayCommand((Single)fSeconds);
        }

        public void ExecuteScript(String sScript, UInt32 oTarget)
        {
            ScriptHost.ExecuteActionService_8_2_ExecuteScript(sScript, oTarget);
        }

        public void ClearAllActions(Int32 nClearCombatState)
        {
            ScriptHost.ExecuteActionService_9_1_ClearAllActions(nClearCombatState);
        }

        public void SetFacing(float fDirection, Int32 bLockToThisOrientation)
        {
            ScriptHost.ExecuteActionService_10_2_SetFacing((Single)fDirection, bLockToThisOrientation);
        }

        public void SetCalendar(Int32 nYear, Int32 nMonth, Int32 nDay)
        {
            ScriptHost.ExecuteActionService_11_3_SetCalendar(nYear, nMonth, nDay);
        }

        public void SetTime(Int32 nHour, Int32 nMinute, Int32 nSecond, Int32 nMillisecond)
        {
            ScriptHost.ExecuteActionService_12_4_SetTime(nHour, nMinute, nSecond, nMillisecond);
        }

        public Int32 GetCalendarYear()
        {
            return ScriptHost.ExecuteActionService_13_0_GetCalendarYear();
        }

        public Int32 GetCalendarMonth()
        {
            return ScriptHost.ExecuteActionService_14_0_GetCalendarMonth();
        }

        public Int32 GetCalendarDay()
        {
            return ScriptHost.ExecuteActionService_15_0_GetCalendarDay();
        }

        public Int32 GetTimeHour()
        {
            return ScriptHost.ExecuteActionService_16_0_GetTimeHour();
        }

        public Int32 GetTimeMinute()
        {
            return ScriptHost.ExecuteActionService_17_0_GetTimeMinute();
        }

        public Int32 GetTimeSecond()
        {
            return ScriptHost.ExecuteActionService_18_0_GetTimeSecond();
        }

        public Int32 GetTimeMillisecond()
        {
            return ScriptHost.ExecuteActionService_19_0_GetTimeMillisecond();
        }

        public void ActionRandomWalk()
        {
            ScriptHost.ExecuteActionService_20_0_ActionRandomWalk();
        }

        public void ActionMoveToLocation(NWLocation lDestination, Int32 bRun)
        {
            ScriptHost.ExecuteActionService_21_2_ActionMoveToLocation(lDestination, bRun);
        }

        public void ActionMoveToObject(UInt32 oMoveTo, Int32 bRun, float fRange)
        {
            ScriptHost.ExecuteActionService_22_3_ActionMoveToObject(oMoveTo, bRun, (Single)fRange);
        }

        public void ActionMoveAwayFromObject(UInt32 oFleeFrom, Int32 bRun, float fMoveAwayRange)
        {
            ScriptHost.ExecuteActionService_23_3_ActionMoveAwayFromObject(oFleeFrom, bRun, (Single)fMoveAwayRange);
        }

        public UInt32 GetArea(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_24_1_GetArea(oTarget);
        }

        public UInt32 GetEnteringObject()
        {
            return ScriptHost.ExecuteActionService_25_0_GetEnteringObject();
        }

        public UInt32 GetExitingObject()
        {
            return ScriptHost.ExecuteActionService_26_0_GetExitingObject();
        }

        public NWScript.Vector3 GetPosition(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_27_1_GetPosition(oTarget);
        }

        public float GetFacing(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_28_1_GetFacing(oTarget);
        }

        public UInt32 GetItemPossessor(UInt32 oItem)
        {
            return ScriptHost.ExecuteActionService_29_1_GetItemPossessor(oItem);
        }

        public UInt32 GetItemPossessedBy(UInt32 oCreature, String sItemTag)
        {
            return ScriptHost.ExecuteActionService_30_2_GetItemPossessedBy(oCreature, sItemTag);
        }

        public UInt32 CreateItemOnObject(String sItemTemplate, UInt32 oTarget, Int32 nStackSize, String sNewTag, Int32 bDisplayFeedback)
        {
            return ScriptHost.ExecuteActionService_31_5_CreateItemOnObject(sItemTemplate, oTarget, nStackSize, sNewTag, bDisplayFeedback);
        }

        public void ActionEquipItem(UInt32 oItem, Int32 nInventorySlot)
        {
            ScriptHost.ExecuteActionService_32_2_ActionEquipItem(oItem, nInventorySlot);
        }

        public void ActionUnequipItem(UInt32 oItem)
        {
            ScriptHost.ExecuteActionService_33_1_ActionUnequipItem(oItem);
        }

        public void ActionPickUpItem(UInt32 oItem)
        {
            ScriptHost.ExecuteActionService_34_1_ActionPickUpItem(oItem);
        }

        public void ActionPutDownItem(UInt32 oItem)
        {
            ScriptHost.ExecuteActionService_35_1_ActionPutDownItem(oItem);
        }

        public UInt32 GetLastAttacker(UInt32 oAttackee)
        {
            return ScriptHost.ExecuteActionService_36_1_GetLastAttacker(oAttackee);
        }

        public void ActionAttack(UInt32 oAttackee, Int32 bPassive)
        {
            ScriptHost.ExecuteActionService_37_2_ActionAttack(oAttackee, bPassive);
        }

        public UInt32 GetNearestCreature(Int32 nFirstCriteriaType, Int32 nFirstCriteriaValue, UInt32 oTarget, Int32 nNth, Int32 nSecondCriteriaType, Int32 nSecondCriteriaValue, Int32 nThirdCriteriaType, Int32 nThirdCriteriaValue)
        {
            return ScriptHost.ExecuteActionService_38_8_GetNearestCreature(nFirstCriteriaType, nFirstCriteriaValue, oTarget, nNth, nSecondCriteriaType, nSecondCriteriaValue, nThirdCriteriaType, nThirdCriteriaValue);
        }

        public void ActionSpeakString(String sStringToSpeak, Int32 nTalkVolume)
        {
            ScriptHost.ExecuteActionService_39_2_ActionSpeakString(sStringToSpeak, nTalkVolume);
        }

        public void ActionPlayAnimation(Int32 nAnimation, float fSpeed, float fDurationSeconds)
        {
            ScriptHost.ExecuteActionService_40_3_ActionPlayAnimation(nAnimation, (Single)fSpeed, (Single)fDurationSeconds);
        }

        public float GetDistanceToObject(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_41_1_GetDistanceToObject(oObject);
        }

        public Int32 GetIsObjectValid(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_42_1_GetIsObjectValid(oObject);
        }

        public void ActionOpenDoor(UInt32 oDoor)
        {
            ScriptHost.ExecuteActionService_43_1_ActionOpenDoor(oDoor);
        }

        public void ActionCloseDoor(UInt32 oDoor)
        {
            ScriptHost.ExecuteActionService_44_1_ActionCloseDoor(oDoor);
        }

        public void SetCameraFacing(float fDirection, float fDistance, float fPitch, Int32 nTransitionType)
        {
            ScriptHost.ExecuteActionService_45_4_SetCameraFacing((Single)fDirection, (Single)fDistance, (Single)fPitch, nTransitionType);
        }

        public void PlaySound(String sSoundName, Int32 bPlayAs2D)
        {
            ScriptHost.ExecuteActionService_46_2_PlaySound(sSoundName, bPlayAs2D);
        }

        public UInt32 GetSpellTargetObject()
        {
            return ScriptHost.ExecuteActionService_47_0_GetSpellTargetObject();
        }

        public void ActionCastSpellAtObject(Int32 nSpell, UInt32 oTarget, Int32 nMetaMagic, Int32 bCheat, Int32 nDomainLevel, Int32 nProjectilePathType, Int32 bInstantSpell)
        {
            ScriptHost.ExecuteActionService_48_7_ActionCastSpellAtObject(nSpell, oTarget, nMetaMagic, bCheat, nDomainLevel, nProjectilePathType, bInstantSpell);
        }

        public Int32 GetCurrentHitPoints(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_49_1_GetCurrentHitPoints(oObject);
        }

        public Int32 GetMaxHitPoints(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_50_1_GetMaxHitPoints(oObject);
        }

        public Int32 GetLocalInt(UInt32 oObject, String sVarName)
        {
            return ScriptHost.ExecuteActionService_51_2_GetLocalInt(oObject, sVarName);
        }

        public float GetLocalFloat(UInt32 oObject, String sVarName)
        {
            return ScriptHost.ExecuteActionService_52_2_GetLocalFloat(oObject, sVarName);
        }

        public String GetLocalString(UInt32 oObject, String sVarName)
        {
            return ScriptHost.ExecuteActionService_53_2_GetLocalString(oObject, sVarName);
        }

        public UInt32 GetLocalObject(UInt32 oObject, String sVarName)
        {
            return ScriptHost.ExecuteActionService_54_2_GetLocalObject(oObject, sVarName);
        }

        public void SetLocalInt(UInt32 oObject, String sVarName, Int32 nValue)
        {
            ScriptHost.ExecuteActionService_55_3_SetLocalInt(oObject, sVarName, nValue);
        }

        public void SetLocalFloat(UInt32 oObject, String sVarName, float fValue)
        {
            ScriptHost.ExecuteActionService_56_3_SetLocalFloat(oObject, sVarName, (Single)fValue);
        }

        public void SetLocalString(UInt32 oObject, String sVarName, String sValue)
        {
            ScriptHost.ExecuteActionService_57_3_SetLocalString(oObject, sVarName, sValue);
        }

        public void SetLocalObject(UInt32 oObject, String sVarName, UInt32 oValue)
        {
            ScriptHost.ExecuteActionService_58_3_SetLocalObject(oObject, sVarName, oValue);
        }

        public Int32 GetStringLength(String sString)
        {
            return ScriptHost.ExecuteActionService_59_1_GetStringLength(sString);
        }

        public String GetStringUpperCase(String sString)
        {
            return ScriptHost.ExecuteActionService_60_1_GetStringUpperCase(sString);
        }

        public String GetStringLowerCase(String sString)
        {
            return ScriptHost.ExecuteActionService_61_1_GetStringLowerCase(sString);
        }

        public String GetStringRight(String sString, Int32 nCount)
        {
            return ScriptHost.ExecuteActionService_62_2_GetStringRight(sString, nCount);
        }

        public String GetStringLeft(String sString, Int32 nCount)
        {
            return ScriptHost.ExecuteActionService_63_2_GetStringLeft(sString, nCount);
        }

        public String InsertString(String sDestination, String sString, Int32 nPosition)
        {
            return ScriptHost.ExecuteActionService_64_3_InsertString(sDestination, sString, nPosition);
        }

        public String GetSubString(String sString, Int32 nStart, Int32 nCount)
        {
            return ScriptHost.ExecuteActionService_65_3_GetSubString(sString, nStart, nCount);
        }

        public Int32 FindSubString(String sString, String sSubString, Int32 nStart)
        {
            return ScriptHost.ExecuteActionService_66_3_FindSubString(sString, sSubString, nStart);
        }

        public float fabs(float fValue)
        {
            return ScriptHost.ExecuteActionService_67_1_fabs((Single)fValue);
        }

        public float cos(float fValue)
        {
            return ScriptHost.ExecuteActionService_68_1_cos((Single)fValue);
        }

        public float sin(float fValue)
        {
            return ScriptHost.ExecuteActionService_69_1_sin((Single)fValue);
        }

        public float tan(float fValue)
        {
            return ScriptHost.ExecuteActionService_70_1_tan((Single)fValue);
        }

        public float acos(float fValue)
        {
            return ScriptHost.ExecuteActionService_71_1_acos((Single)fValue);
        }

        public float asin(float fValue)
        {
            return ScriptHost.ExecuteActionService_72_1_asin((Single)fValue);
        }

        public float atan(float fValue)
        {
            return ScriptHost.ExecuteActionService_73_1_atan((Single)fValue);
        }

        public float log(float fValue)
        {
            return ScriptHost.ExecuteActionService_74_1_log((Single)fValue);
        }

        public float pow(float fValue, float fExponent)
        {
            return ScriptHost.ExecuteActionService_75_2_pow((Single)fValue, (Single)fExponent);
        }

        public float sqrt(float fValue)
        {
            return ScriptHost.ExecuteActionService_76_1_sqrt((Single)fValue);
        }

        public Int32 abs(Int32 nValue)
        {
            return ScriptHost.ExecuteActionService_77_1_abs(nValue);
        }

        public NWEffect EffectHeal(Int32 nDamageToHeal)
        {
            return ScriptHost.ExecuteActionService_78_1_EffectHeal(nDamageToHeal);
        }

        public NWEffect EffectDamage(Int32 nDamageAmount, Int32 nDamageType, Int32 nDamagePower, Int32 nIgnoreResistances)
        {
            return ScriptHost.ExecuteActionService_79_4_EffectDamage(nDamageAmount, nDamageType, nDamagePower, nIgnoreResistances);
        }

        public NWEffect EffectAbilityIncrease(Int32 nAbilityToIncrease, Int32 nModifyBy)
        {
            return ScriptHost.ExecuteActionService_80_2_EffectAbilityIncrease(nAbilityToIncrease, nModifyBy);
        }

        public NWEffect EffectDamageResistance(Int32 nDamageType, Int32 nAmount, Int32 nLimit)
        {
            return ScriptHost.ExecuteActionService_81_3_EffectDamageResistance(nDamageType, nAmount, nLimit);
        }

        public NWEffect EffectResurrection()
        {
            return ScriptHost.ExecuteActionService_82_0_EffectResurrection();
        }

        public NWEffect EffectSummonCreature(String sCreatureResref, Int32 nVisualEffectId, float fDelaySeconds, Int32 nUseAppearAnimation)
        {
            return ScriptHost.ExecuteActionService_83_4_EffectSummonCreature(sCreatureResref, nVisualEffectId, (Single)fDelaySeconds, nUseAppearAnimation);
        }

        public Int32 GetCasterLevel(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_84_1_GetCasterLevel(oCreature);
        }

        public NWEffect GetFirstEffect(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_85_1_GetFirstEffect(oCreature);
        }

        public NWEffect GetNextEffect(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_86_1_GetNextEffect(oCreature);
        }

        public void RemoveEffect(UInt32 oCreature, NWEffect eEffect)
        {
            ScriptHost.ExecuteActionService_87_2_RemoveEffect(oCreature, eEffect);
        }

        public Int32 GetIsEffectValid(NWEffect eEffect)
        {
            return ScriptHost.ExecuteActionService_88_1_GetIsEffectValid(eEffect);
        }

        public Int32 GetEffectDurationType(NWEffect eEffect)
        {
            return ScriptHost.ExecuteActionService_89_1_GetEffectDurationType(eEffect);
        }

        public Int32 GetEffectSubType(NWEffect eEffect)
        {
            return ScriptHost.ExecuteActionService_90_1_GetEffectSubType(eEffect);
        }

        public UInt32 GetEffectCreator(NWEffect eEffect)
        {
            return ScriptHost.ExecuteActionService_91_1_GetEffectCreator(eEffect);
        }

        public String IntToString(Int32 nInteger)
        {
            return ScriptHost.ExecuteActionService_92_1_IntToString(nInteger);
        }

        public UInt32 GetFirstObjectInArea(UInt32 oArea)
        {
            return ScriptHost.ExecuteActionService_93_1_GetFirstObjectInArea(oArea);
        }

        public UInt32 GetNextObjectInArea(UInt32 oArea)
        {
            return ScriptHost.ExecuteActionService_94_1_GetNextObjectInArea(oArea);
        }

        public Int32 d2(Int32 nNumDice)
        {
            return ScriptHost.ExecuteActionService_95_1_d2(nNumDice);
        }

        public Int32 d3(Int32 nNumDice)
        {
            return ScriptHost.ExecuteActionService_96_1_d3(nNumDice);
        }

        public Int32 d4(Int32 nNumDice)
        {
            return ScriptHost.ExecuteActionService_97_1_d4(nNumDice);
        }

        public Int32 d6(Int32 nNumDice)
        {
            return ScriptHost.ExecuteActionService_98_1_d6(nNumDice);
        }

        public Int32 d8(Int32 nNumDice)
        {
            return ScriptHost.ExecuteActionService_99_1_d8(nNumDice);
        }

        public Int32 d10(Int32 nNumDice)
        {
            return ScriptHost.ExecuteActionService_100_1_d10(nNumDice);
        }

        public Int32 d12(Int32 nNumDice)
        {
            return ScriptHost.ExecuteActionService_101_1_d12(nNumDice);
        }

        public Int32 d20(Int32 nNumDice)
        {
            return ScriptHost.ExecuteActionService_102_1_d20(nNumDice);
        }

        public Int32 d100(Int32 nNumDice)
        {
            return ScriptHost.ExecuteActionService_103_1_d100(nNumDice);
        }

        public float VectorMagnitude(NWScript.Vector3 vVector)
        {
            return ScriptHost.ExecuteActionService_104_3_VectorMagnitude(vVector.z, vVector.y, vVector.x);
        }

        public Int32 GetMetaMagicFeat()
        {
            return ScriptHost.ExecuteActionService_105_0_GetMetaMagicFeat();
        }

        public Int32 GetObjectType(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_106_1_GetObjectType(oTarget);
        }

        public Int32 GetRacialType(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_107_1_GetRacialType(oCreature);
        }

        public Int32 FortitudeSave(UInt32 oCreature, Int32 nDC, Int32 nSaveType, UInt32 oSaveVersus)
        {
            return ScriptHost.ExecuteActionService_108_4_FortitudeSave(oCreature, nDC, nSaveType, oSaveVersus);
        }

        public Int32 ReflexSave(UInt32 oCreature, Int32 nDC, Int32 nSaveType, UInt32 oSaveVersus)
        {
            return ScriptHost.ExecuteActionService_109_4_ReflexSave(oCreature, nDC, nSaveType, oSaveVersus);
        }

        public Int32 WillSave(UInt32 oCreature, Int32 nDC, Int32 nSaveType, UInt32 oSaveVersus)
        {
            return ScriptHost.ExecuteActionService_110_4_WillSave(oCreature, nDC, nSaveType, oSaveVersus);
        }

        public Int32 GetSpellSaveDC()
        {
            return ScriptHost.ExecuteActionService_111_0_GetSpellSaveDC();
        }

        public NWEffect MagicalEffect(NWEffect eEffect)
        {
            return ScriptHost.ExecuteActionService_112_1_MagicalEffect(eEffect);
        }

        public NWEffect SupernaturalEffect(NWEffect eEffect)
        {
            return ScriptHost.ExecuteActionService_113_1_SupernaturalEffect(eEffect);
        }

        public NWEffect ExtraordinaryEffect(NWEffect eEffect)
        {
            return ScriptHost.ExecuteActionService_114_1_ExtraordinaryEffect(eEffect);
        }

        public NWEffect EffectACIncrease(Int32 nValue, Int32 nModifyType, Int32 nDamageType, Int32 bVsSpiritsOnly)
        {
            return ScriptHost.ExecuteActionService_115_4_EffectACIncrease(nValue, nModifyType, nDamageType, bVsSpiritsOnly);
        }

        public Int32 GetAC(UInt32 oObject, Int32 nForFutureUse)
        {
            return ScriptHost.ExecuteActionService_116_2_GetAC(oObject, nForFutureUse);
        }

        public NWEffect EffectSavingThrowIncrease(Int32 nSave, Int32 nValue, Int32 nSaveType, Int32 bVsSpiritsOnly)
        {
            return ScriptHost.ExecuteActionService_117_4_EffectSavingThrowIncrease(nSave, nValue, nSaveType, bVsSpiritsOnly);
        }

        public NWEffect EffectAttackIncrease(Int32 nBonus, Int32 nModifierType)
        {
            return ScriptHost.ExecuteActionService_118_2_EffectAttackIncrease(nBonus, nModifierType);
        }

        public NWEffect EffectDamageReduction(Int32 nAmount, Int32 nDRSubType, Int32 nLimit, Int32 nDRType)
        {
            return ScriptHost.ExecuteActionService_119_4_EffectDamageReduction(nAmount, nDRSubType, nLimit, nDRType);
        }

        public NWEffect EffectDamageIncrease(Int32 nBonus, Int32 nDamageType, Int32 nVersusRace)
        {
            return ScriptHost.ExecuteActionService_120_3_EffectDamageIncrease(nBonus, nDamageType, nVersusRace);
        }

        public float RoundsToSeconds(Int32 nRounds)
        {
            return ScriptHost.ExecuteActionService_121_1_RoundsToSeconds(nRounds);
        }

        public float HoursToSeconds(Int32 nHours)
        {
            return ScriptHost.ExecuteActionService_122_1_HoursToSeconds(nHours);
        }

        public float TurnsToSeconds(Int32 nTurns)
        {
            return ScriptHost.ExecuteActionService_123_1_TurnsToSeconds(nTurns);
        }

        public Int32 GetLawChaosValue(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_124_1_GetLawChaosValue(oCreature);
        }

        public Int32 GetGoodEvilValue(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_125_1_GetGoodEvilValue(oCreature);
        }

        public Int32 GetAlignmentLawChaos(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_126_1_GetAlignmentLawChaos(oCreature);
        }

        public Int32 GetAlignmentGoodEvil(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_127_1_GetAlignmentGoodEvil(oCreature);
        }

        public UInt32 GetFirstObjectInShape(Int32 nShape, float fSize, NWLocation lTarget, Int32 bLineOfSight, Int32 nObjectFilter, NWScript.Vector3 vOrigin)
        {
            return ScriptHost.ExecuteActionService_128_8_GetFirstObjectInShape(nShape, (Single)fSize, lTarget, bLineOfSight, nObjectFilter, vOrigin.z, vOrigin.y, vOrigin.x);
        }

        public UInt32 GetNextObjectInShape(Int32 nShape, float fSize, NWLocation lTarget, Int32 bLineOfSight, Int32 nObjectFilter, NWScript.Vector3 vOrigin)
        {
            return ScriptHost.ExecuteActionService_129_8_GetNextObjectInShape(nShape, (Single)fSize, lTarget, bLineOfSight, nObjectFilter, vOrigin.z, vOrigin.y, vOrigin.x);
        }

        public NWEffect EffectEntangle()
        {
            return ScriptHost.ExecuteActionService_130_0_EffectEntangle();
        }

        public void SignalEvent(UInt32 oObject, NWEvent evToRun)
        {
            ScriptHost.ExecuteActionService_131_2_SignalEvent(oObject, evToRun);
        }

        public NWEvent EventUserDefined(Int32 nUserDefinedEventNumber)
        {
            return ScriptHost.ExecuteActionService_132_1_EventUserDefined(nUserDefinedEventNumber);
        }

        public NWEffect EffectDeath(Int32 nSpectacularDeath, Int32 nDisplayFeedback, Int32 nIgnoreDeathImmunity, Int32 bPurgeEffects)
        {
            return ScriptHost.ExecuteActionService_133_4_EffectDeath(nSpectacularDeath, nDisplayFeedback, nIgnoreDeathImmunity, bPurgeEffects);
        }

        public NWEffect EffectKnockdown()
        {
            return ScriptHost.ExecuteActionService_134_0_EffectKnockdown();
        }

        public void ActionGiveItem(UInt32 oItem, UInt32 oGiveTo, Int32 bDisplayFeedback)
        {
            ScriptHost.ExecuteActionService_135_3_ActionGiveItem(oItem, oGiveTo, bDisplayFeedback);
        }

        public void ActionTakeItem(UInt32 oItem, UInt32 oTakeFrom, Int32 bDisplayFeedback)
        {
            ScriptHost.ExecuteActionService_136_3_ActionTakeItem(oItem, oTakeFrom, bDisplayFeedback);
        }

        public NWScript.Vector3 VectorNormalize(NWScript.Vector3 vVector)
        {
            return ScriptHost.ExecuteActionService_137_3_VectorNormalize(vVector.z, vVector.y, vVector.x);
        }

        public NWEffect EffectCurse(Int32 nStrMod, Int32 nDexMod, Int32 nConMod, Int32 nIntMod, Int32 nWisMod, Int32 nChaMod)
        {
            return ScriptHost.ExecuteActionService_138_6_EffectCurse(nStrMod, nDexMod, nConMod, nIntMod, nWisMod, nChaMod);
        }

        public Int32 GetAbilityScore(UInt32 oCreature, Int32 nAbilityType, Int32 nBaseAttribute)
        {
            return ScriptHost.ExecuteActionService_139_3_GetAbilityScore(oCreature, nAbilityType, nBaseAttribute);
        }

        public Int32 GetIsDead(UInt32 oCreature, Int32 bIgnoreDying)
        {
            return ScriptHost.ExecuteActionService_140_2_GetIsDead(oCreature, bIgnoreDying);
        }

        public void PrintVector(NWScript.Vector3 vVector, Int32 bPrepend)
        {
            ScriptHost.ExecuteActionService_141_4_PrintVector(vVector.z, vVector.y, vVector.x, bPrepend);
        }

        public NWScript.Vector3 Vector(float x, float y, float z)
        {
            return ScriptHost.ExecuteActionService_142_3_Vector((Single)x, (Single)y, (Single)z);
        }

        public void SetFacingPoint(NWScript.Vector3 vTarget, Int32 bLockToThisOrientation)
        {
            ScriptHost.ExecuteActionService_143_4_SetFacingPoint(vTarget.z, vTarget.y, vTarget.x, bLockToThisOrientation);
        }

        public NWScript.Vector3 AngleToVector(float fAngle)
        {
            return ScriptHost.ExecuteActionService_144_1_AngleToVector((Single)fAngle);
        }

        public float VectorToAngle(NWScript.Vector3 vVector)
        {
            return ScriptHost.ExecuteActionService_145_3_VectorToAngle(vVector.z, vVector.y, vVector.x);
        }

        public Int32 TouchAttackMelee(UInt32 oTarget, Int32 bDisplayFeedback, Int32 nBonus)
        {
            return ScriptHost.ExecuteActionService_146_3_TouchAttackMelee(oTarget, bDisplayFeedback, nBonus);
        }

        public Int32 TouchAttackRanged(UInt32 oTarget, Int32 bDisplayFeedback, Int32 nBonus)
        {
            return ScriptHost.ExecuteActionService_147_3_TouchAttackRanged(oTarget, bDisplayFeedback, nBonus);
        }

        public NWEffect EffectParalyze(Int32 nSaveDC, Int32 nSave, Int32 bSaveEveryRound)
        {
            return ScriptHost.ExecuteActionService_148_3_EffectParalyze(nSaveDC, nSave, bSaveEveryRound);
        }

        public NWEffect EffectSpellImmunity(Int32 nImmunityToSpell)
        {
            return ScriptHost.ExecuteActionService_149_1_EffectSpellImmunity(nImmunityToSpell);
        }

        public NWEffect EffectDeaf()
        {
            return ScriptHost.ExecuteActionService_150_0_EffectDeaf();
        }

        public float GetDistanceBetween(UInt32 oObjectA, UInt32 oObjectB)
        {
            return ScriptHost.ExecuteActionService_151_2_GetDistanceBetween(oObjectA, oObjectB);
        }

        public void SetLocalLocation(UInt32 oObject, String sVarName, NWLocation lValue)
        {
            ScriptHost.ExecuteActionService_152_3_SetLocalLocation(oObject, sVarName, lValue);
        }

        public NWLocation GetLocalLocation(UInt32 oObject, String sVarName)
        {
            return ScriptHost.ExecuteActionService_153_2_GetLocalLocation(oObject, sVarName);
        }

        public NWEffect EffectSleep()
        {
            return ScriptHost.ExecuteActionService_154_0_EffectSleep();
        }

        public UInt32 GetItemInSlot(Int32 nInventorySlot, UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_155_2_GetItemInSlot(nInventorySlot, oCreature);
        }

        public NWEffect EffectCharmed()
        {
            return ScriptHost.ExecuteActionService_156_0_EffectCharmed();
        }

        public NWEffect EffectConfused()
        {
            return ScriptHost.ExecuteActionService_157_0_EffectConfused();
        }

        public NWEffect EffectFrightened()
        {
            return ScriptHost.ExecuteActionService_158_0_EffectFrightened();
        }

        public NWEffect EffectDominated()
        {
            return ScriptHost.ExecuteActionService_159_0_EffectDominated();
        }

        public NWEffect EffectDazed()
        {
            return ScriptHost.ExecuteActionService_160_0_EffectDazed();
        }

        public NWEffect EffectStunned()
        {
            return ScriptHost.ExecuteActionService_161_0_EffectStunned();
        }

        public void SetCommandable(Int32 bCommandable, UInt32 oTarget)
        {
            ScriptHost.ExecuteActionService_162_2_SetCommandable(bCommandable, oTarget);
        }

        public Int32 GetCommandable(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_163_1_GetCommandable(oTarget);
        }

        public NWEffect EffectRegenerate(Int32 nAmount, float fIntervalSeconds)
        {
            return ScriptHost.ExecuteActionService_164_2_EffectRegenerate(nAmount, (Single)fIntervalSeconds);
        }

        public NWEffect EffectMovementSpeedIncrease(Int32 nPercentChange)
        {
            return ScriptHost.ExecuteActionService_165_1_EffectMovementSpeedIncrease(nPercentChange);
        }

        public Int32 GetHitDice(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_166_1_GetHitDice(oCreature);
        }

        public void ActionForceFollowObject(UInt32 oFollow, float fFollowDistance, Int32 iFollowPosition)
        {
            ScriptHost.ExecuteActionService_167_3_ActionForceFollowObject(oFollow, (Single)fFollowDistance, iFollowPosition);
        }

        public String GetTag(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_168_1_GetTag(oObject);
        }

        public Int32 ResistSpell(UInt32 oCaster, UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_169_2_ResistSpell(oCaster, oTarget);
        }

        public Int32 GetEffectType(NWEffect eEffect)
        {
            return ScriptHost.ExecuteActionService_170_1_GetEffectType(eEffect);
        }

        public NWEffect EffectAreaOfEffect(Int32 nAreaEffectId, String sOnEnterScript, String sHeartbeatScript, String sOnExitScript, String sEffectTag)
        {
            return ScriptHost.ExecuteActionService_171_5_EffectAreaOfEffect(nAreaEffectId, sOnEnterScript, sHeartbeatScript, sOnExitScript, sEffectTag);
        }

        public Int32 GetFactionEqual(UInt32 oFirstObject, UInt32 oSecondObject)
        {
            return ScriptHost.ExecuteActionService_172_2_GetFactionEqual(oFirstObject, oSecondObject);
        }

        public void ChangeFaction(UInt32 oObjectToChangeFaction, UInt32 oMemberOfFactionToJoin)
        {
            ScriptHost.ExecuteActionService_173_2_ChangeFaction(oObjectToChangeFaction, oMemberOfFactionToJoin);
        }

        public Int32 GetIsListening(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_174_1_GetIsListening(oObject);
        }

        public void SetListening(UInt32 oObject, Int32 bValue)
        {
            ScriptHost.ExecuteActionService_175_2_SetListening(oObject, bValue);
        }

        public void SetListenPattern(UInt32 oObject, String sPattern, Int32 nNumber)
        {
            ScriptHost.ExecuteActionService_176_3_SetListenPattern(oObject, sPattern, nNumber);
        }

        public Int32 TestStringAgainstPattern(String sPattern, String sStringToTest)
        {
            return ScriptHost.ExecuteActionService_177_2_TestStringAgainstPattern(sPattern, sStringToTest);
        }

        public String GetMatchedSubstring(Int32 nString)
        {
            return ScriptHost.ExecuteActionService_178_1_GetMatchedSubstring(nString);
        }

        public Int32 GetMatchedSubstringsCount()
        {
            return ScriptHost.ExecuteActionService_179_0_GetMatchedSubstringsCount();
        }

        public NWEffect EffectVisualEffect(Int32 nVisualEffectId, Int32 nMissEffect)
        {
            return ScriptHost.ExecuteActionService_180_2_EffectVisualEffect(nVisualEffectId, nMissEffect);
        }

        public UInt32 GetFactionWeakestMember(UInt32 oFactionMember, Int32 bMustBeVisible)
        {
            return ScriptHost.ExecuteActionService_181_2_GetFactionWeakestMember(oFactionMember, bMustBeVisible);
        }

        public UInt32 GetFactionStrongestMember(UInt32 oFactionMember, Int32 bMustBeVisible)
        {
            return ScriptHost.ExecuteActionService_182_2_GetFactionStrongestMember(oFactionMember, bMustBeVisible);
        }

        public UInt32 GetFactionMostDamagedMember(UInt32 oFactionMember, Int32 bMustBeVisible)
        {
            return ScriptHost.ExecuteActionService_183_2_GetFactionMostDamagedMember(oFactionMember, bMustBeVisible);
        }

        public UInt32 GetFactionLeastDamagedMember(UInt32 oFactionMember, Int32 bMustBeVisible)
        {
            return ScriptHost.ExecuteActionService_184_2_GetFactionLeastDamagedMember(oFactionMember, bMustBeVisible);
        }

        public Int32 GetFactionGold(UInt32 oFactionMember)
        {
            return ScriptHost.ExecuteActionService_185_1_GetFactionGold(oFactionMember);
        }

        public Int32 GetFactionAverageReputation(UInt32 oSourceFactionMember, UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_186_2_GetFactionAverageReputation(oSourceFactionMember, oTarget);
        }

        public Int32 GetFactionAverageGoodEvilAlignment(UInt32 oFactionMember)
        {
            return ScriptHost.ExecuteActionService_187_1_GetFactionAverageGoodEvilAlignment(oFactionMember);
        }

        public Int32 GetFactionAverageLawChaosAlignment(UInt32 oFactionMember)
        {
            return ScriptHost.ExecuteActionService_188_1_GetFactionAverageLawChaosAlignment(oFactionMember);
        }

        public Int32 GetFactionAverageLevel(UInt32 oFactionMember)
        {
            return ScriptHost.ExecuteActionService_189_1_GetFactionAverageLevel(oFactionMember);
        }

        public Int32 GetFactionAverageXP(UInt32 oFactionMember)
        {
            return ScriptHost.ExecuteActionService_190_1_GetFactionAverageXP(oFactionMember);
        }

        public Int32 GetFactionMostFrequentClass(UInt32 oFactionMember)
        {
            return ScriptHost.ExecuteActionService_191_1_GetFactionMostFrequentClass(oFactionMember);
        }

        public UInt32 GetFactionWorstAC(UInt32 oFactionMember, Int32 bMustBeVisible)
        {
            return ScriptHost.ExecuteActionService_192_2_GetFactionWorstAC(oFactionMember, bMustBeVisible);
        }

        public UInt32 GetFactionBestAC(UInt32 oFactionMember, Int32 bMustBeVisible)
        {
            return ScriptHost.ExecuteActionService_193_2_GetFactionBestAC(oFactionMember, bMustBeVisible);
        }

        public void ActionSit(UInt32 oChair)
        {
            ScriptHost.ExecuteActionService_194_1_ActionSit(oChair);
        }

        public Int32 GetListenPatternNumber()
        {
            return ScriptHost.ExecuteActionService_195_0_GetListenPatternNumber();
        }

        public void ActionJumpToObject(UInt32 oToJumpTo, Int32 bWalkStraightLineToPoint)
        {
            ScriptHost.ExecuteActionService_196_2_ActionJumpToObject(oToJumpTo, bWalkStraightLineToPoint);
        }

        public UInt32 GetWaypointByTag(String sWaypointTag)
        {
            return ScriptHost.ExecuteActionService_197_1_GetWaypointByTag(sWaypointTag);
        }

        public UInt32 GetTransitionTarget(UInt32 oTransition)
        {
            return ScriptHost.ExecuteActionService_198_1_GetTransitionTarget(oTransition);
        }

        public NWEffect EffectLinkEffects(NWEffect eChildEffect, NWEffect eParentEffect)
        {
            return ScriptHost.ExecuteActionService_199_2_EffectLinkEffects(eChildEffect, eParentEffect);
        }

        public UInt32 GetObjectByTag(String sTag, Int32 nNth)
        {
            return ScriptHost.ExecuteActionService_200_2_GetObjectByTag(sTag, nNth);
        }

        public void AdjustAlignment(UInt32 oSubject, Int32 nAlignment, Int32 nShift)
        {
            ScriptHost.ExecuteActionService_201_3_AdjustAlignment(oSubject, nAlignment, nShift);
        }

        public void ActionWait(float fSeconds)
        {
            ScriptHost.ExecuteActionService_202_1_ActionWait((Single)fSeconds);
        }

        public void SetAreaTransitionBMP(Int32 nPredefinedAreaTransition, String sCustomAreaTransitionBMP)
        {
            ScriptHost.ExecuteActionService_203_2_SetAreaTransitionBMP(nPredefinedAreaTransition, sCustomAreaTransitionBMP);
        }

        public void ActionStartConversation(UInt32 oObjectToConverseWith, String sDialogResRef, Int32 bPrivateConversation, Int32 bPlayHello, Int32 bIgnoreStartDistance, Int32 bDisableCutsceneBars)
        {
            ScriptHost.ExecuteActionService_204_6_ActionStartConversation(oObjectToConverseWith, sDialogResRef, bPrivateConversation, bPlayHello, bIgnoreStartDistance, bDisableCutsceneBars);
        }

        public void ActionPauseConversation()
        {
            ScriptHost.ExecuteActionService_205_0_ActionPauseConversation();
        }

        public void ActionResumeConversation()
        {
            ScriptHost.ExecuteActionService_206_0_ActionResumeConversation();
        }

        public NWEffect EffectBeam(Int32 nBeamVisualEffect, UInt32 oEffector, Int32 nBodyPart, Int32 bMissEffect)
        {
            return ScriptHost.ExecuteActionService_207_4_EffectBeam(nBeamVisualEffect, oEffector, nBodyPart, bMissEffect);
        }

        public Int32 GetReputation(UInt32 oSource, UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_208_2_GetReputation(oSource, oTarget);
        }

        public void AdjustReputation(UInt32 oTarget, UInt32 oSourceFactionMember, Int32 nAdjustment)
        {
            ScriptHost.ExecuteActionService_209_3_AdjustReputation(oTarget, oSourceFactionMember, nAdjustment);
        }

        public UInt32 GetSittingCreature(UInt32 oChair)
        {
            return ScriptHost.ExecuteActionService_210_1_GetSittingCreature(oChair);
        }

        public UInt32 GetGoingToBeAttackedBy(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_211_1_GetGoingToBeAttackedBy(oTarget);
        }

        public NWEffect EffectSpellResistanceIncrease(Int32 nValue, Int32 nUses)
        {
            return ScriptHost.ExecuteActionService_212_2_EffectSpellResistanceIncrease(nValue, nUses);
        }

        public NWLocation GetLocation(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_213_1_GetLocation(oObject);
        }

        public void ActionJumpToLocation(NWLocation lLocation)
        {
            ScriptHost.ExecuteActionService_214_1_ActionJumpToLocation(lLocation);
        }

        public NWLocation Location(UInt32 oArea, NWScript.Vector3 vPosition, float fOrientation)
        {
            return ScriptHost.ExecuteActionService_215_5_Location(oArea, vPosition.z, vPosition.y, vPosition.x, (Single)fOrientation);
        }

        public void ApplyEffectAtLocation(Int32 nDurationType, NWEffect eEffect, NWLocation lLocation, float fDuration)
        {
            ScriptHost.ExecuteActionService_216_4_ApplyEffectAtLocation(nDurationType, eEffect, lLocation, (Single)fDuration);
        }

        public Int32 GetIsPC(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_217_1_GetIsPC(oCreature);
        }

        public float FeetToMeters(float fFeet)
        {
            return ScriptHost.ExecuteActionService_218_1_FeetToMeters((Single)fFeet);
        }

        public float YardsToMeters(float fYards)
        {
            return ScriptHost.ExecuteActionService_219_1_YardsToMeters((Single)fYards);
        }

        public void ApplyEffectToObject(Int32 nDurationType, NWEffect eEffect, UInt32 oTarget, float fDuration)
        {
            ScriptHost.ExecuteActionService_220_4_ApplyEffectToObject(nDurationType, eEffect, oTarget, (Single)fDuration);
        }

        public void SpeakString(String sStringToSpeak, Int32 nTalkVolume)
        {
            ScriptHost.ExecuteActionService_221_2_SpeakString(sStringToSpeak, nTalkVolume);
        }

        public NWLocation GetSpellTargetLocation()
        {
            return ScriptHost.ExecuteActionService_222_0_GetSpellTargetLocation();
        }

        public NWScript.Vector3 GetPositionFromLocation(NWLocation lLocation)
        {
            return ScriptHost.ExecuteActionService_223_1_GetPositionFromLocation(lLocation);
        }

        public UInt32 GetAreaFromLocation(NWLocation lLocation)
        {
            return ScriptHost.ExecuteActionService_224_1_GetAreaFromLocation(lLocation);
        }

        public float GetFacingFromLocation(NWLocation lLocation)
        {
            return ScriptHost.ExecuteActionService_225_1_GetFacingFromLocation(lLocation);
        }

        public UInt32 GetNearestCreatureToLocation(Int32 nFirstCriteriaType, Int32 nFirstCriteriaValue, NWLocation lLocation, Int32 nNth, Int32 nSecondCriteriaType, Int32 nSecondCriteriaValue, Int32 nThirdCriteriaType, Int32 nThirdCriteriaValue)
        {
            return ScriptHost.ExecuteActionService_226_8_GetNearestCreatureToLocation(nFirstCriteriaType, nFirstCriteriaValue, lLocation, nNth, nSecondCriteriaType, nSecondCriteriaValue, nThirdCriteriaType, nThirdCriteriaValue);
        }

        public UInt32 GetNearestObject(Int32 nObjectType, UInt32 oTarget, Int32 nNth)
        {
            return ScriptHost.ExecuteActionService_227_3_GetNearestObject(nObjectType, oTarget, nNth);
        }

        public UInt32 GetNearestObjectToLocation(Int32 nObjectType, NWLocation lLocation, Int32 nNth)
        {
            return ScriptHost.ExecuteActionService_228_3_GetNearestObjectToLocation(nObjectType, lLocation, nNth);
        }

        public UInt32 GetNearestObjectByTag(String sTag, UInt32 oTarget, Int32 nNth)
        {
            return ScriptHost.ExecuteActionService_229_3_GetNearestObjectByTag(sTag, oTarget, nNth);
        }

        public float IntToFloat(Int32 nInteger)
        {
            return ScriptHost.ExecuteActionService_230_1_IntToFloat(nInteger);
        }

        public Int32 FloatToInt(float fFloat)
        {
            return ScriptHost.ExecuteActionService_231_1_FloatToInt((Single)fFloat);
        }

        public Int32 StringToInt(String sNumber)
        {
            return ScriptHost.ExecuteActionService_232_1_StringToInt(sNumber);
        }

        public float StringToFloat(String sNumber)
        {
            return ScriptHost.ExecuteActionService_233_1_StringToFloat(sNumber);
        }

        public void ActionCastSpellAtLocation(Int32 nSpell, NWLocation lTargetLocation, Int32 nMetaMagic, Int32 bCheat, Int32 nProjectilePathType, Int32 bInstantSpell, Int32 nDomainLevel)
        {
            ScriptHost.ExecuteActionService_234_7_ActionCastSpellAtLocation(nSpell, lTargetLocation, nMetaMagic, bCheat, nProjectilePathType, bInstantSpell, nDomainLevel);
        }

        public Int32 GetIsEnemy(UInt32 oTarget, UInt32 oSource)
        {
            return ScriptHost.ExecuteActionService_235_2_GetIsEnemy(oTarget, oSource);
        }

        public Int32 GetIsFriend(UInt32 oTarget, UInt32 oSource)
        {
            return ScriptHost.ExecuteActionService_236_2_GetIsFriend(oTarget, oSource);
        }

        public Int32 GetIsNeutral(UInt32 oTarget, UInt32 oSource)
        {
            return ScriptHost.ExecuteActionService_237_2_GetIsNeutral(oTarget, oSource);
        }

        public UInt32 GetPCSpeaker()
        {
            return ScriptHost.ExecuteActionService_238_0_GetPCSpeaker();
        }

        public String GetStringByStrRef(Int32 nStrRef, Int32 nGender)
        {
            return ScriptHost.ExecuteActionService_239_2_GetStringByStrRef(nStrRef, nGender);
        }

        public void ActionSpeakStringByStrRef(Int32 nStrRef, Int32 nTalkVolume)
        {
            ScriptHost.ExecuteActionService_240_2_ActionSpeakStringByStrRef(nStrRef, nTalkVolume);
        }

        public void DestroyObject(UInt32 oDestroy, float fDelay, Int32 nDisplayFeedback)
        {
            ScriptHost.ExecuteActionService_241_3_DestroyObject(oDestroy, (Single)fDelay, nDisplayFeedback);
        }

        public UInt32 GetModule()
        {
            return ScriptHost.ExecuteActionService_242_0_GetModule();
        }

        public UInt32 CreateObject(Int32 nObjectType, String sTemplate, NWLocation lLocation, Int32 bUseAppearAnimation, String sNewTag)
        {
            return ScriptHost.ExecuteActionService_243_5_CreateObject(nObjectType, sTemplate, lLocation, bUseAppearAnimation, sNewTag);
        }

        public NWEvent EventSpellCastAt(UInt32 oCaster, Int32 nSpell, Int32 bHarmful)
        {
            return ScriptHost.ExecuteActionService_244_3_EventSpellCastAt(oCaster, nSpell, bHarmful);
        }

        public UInt32 GetLastSpellCaster()
        {
            return ScriptHost.ExecuteActionService_245_0_GetLastSpellCaster();
        }

        public Int32 GetLastSpell()
        {
            return ScriptHost.ExecuteActionService_246_0_GetLastSpell();
        }

        public Int32 GetUserDefinedEventNumber()
        {
            return ScriptHost.ExecuteActionService_247_0_GetUserDefinedEventNumber();
        }

        public Int32 GetSpellId()
        {
            return ScriptHost.ExecuteActionService_248_0_GetSpellId();
        }

        public String RandomName()
        {
            return ScriptHost.ExecuteActionService_249_0_RandomName();
        }

        public NWEffect EffectPoison(Int32 nPoisonType)
        {
            return ScriptHost.ExecuteActionService_250_1_EffectPoison(nPoisonType);
        }

        public NWEffect EffectDisease(Int32 nDiseaseType)
        {
            return ScriptHost.ExecuteActionService_251_1_EffectDisease(nDiseaseType);
        }

        public NWEffect EffectSilence()
        {
            return ScriptHost.ExecuteActionService_252_0_EffectSilence();
        }

        public String GetName(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_253_1_GetName(oObject);
        }

        public UInt32 GetLastSpeaker()
        {
            return ScriptHost.ExecuteActionService_254_0_GetLastSpeaker();
        }

        public Int32 BeginConversation(String sResRef, UInt32 oObjectToDialog, Int32 bPreventHello)
        {
            return ScriptHost.ExecuteActionService_255_3_BeginConversation(sResRef, oObjectToDialog, bPreventHello);
        }

        public UInt32 GetLastPerceived()
        {
            return ScriptHost.ExecuteActionService_256_0_GetLastPerceived();
        }

        public Int32 GetLastPerceptionHeard()
        {
            return ScriptHost.ExecuteActionService_257_0_GetLastPerceptionHeard();
        }

        public Int32 GetLastPerceptionInaudible()
        {
            return ScriptHost.ExecuteActionService_258_0_GetLastPerceptionInaudible();
        }

        public Int32 GetLastPerceptionSeen()
        {
            return ScriptHost.ExecuteActionService_259_0_GetLastPerceptionSeen();
        }

        public UInt32 GetLastClosedBy()
        {
            return ScriptHost.ExecuteActionService_260_0_GetLastClosedBy();
        }

        public Int32 GetLastPerceptionVanished()
        {
            return ScriptHost.ExecuteActionService_261_0_GetLastPerceptionVanished();
        }

        public UInt32 GetFirstInPersistentObject(UInt32 oPersistentObject, Int32 nResidentObjectType, Int32 nPersistentZone)
        {
            return ScriptHost.ExecuteActionService_262_3_GetFirstInPersistentObject(oPersistentObject, nResidentObjectType, nPersistentZone);
        }

        public UInt32 GetNextInPersistentObject(UInt32 oPersistentObject, Int32 nResidentObjectType, Int32 nPersistentZone)
        {
            return ScriptHost.ExecuteActionService_263_3_GetNextInPersistentObject(oPersistentObject, nResidentObjectType, nPersistentZone);
        }

        public UInt32 GetAreaOfEffectCreator(UInt32 oAreaOfEffectObject)
        {
            return ScriptHost.ExecuteActionService_264_1_GetAreaOfEffectCreator(oAreaOfEffectObject);
        }

        public void DeleteLocalInt(UInt32 oObject, String sVarName)
        {
            ScriptHost.ExecuteActionService_265_2_DeleteLocalInt(oObject, sVarName);
        }

        public void DeleteLocalFloat(UInt32 oObject, String sVarName)
        {
            ScriptHost.ExecuteActionService_266_2_DeleteLocalFloat(oObject, sVarName);
        }

        public void DeleteLocalString(UInt32 oObject, String sVarName)
        {
            ScriptHost.ExecuteActionService_267_2_DeleteLocalString(oObject, sVarName);
        }

        public void DeleteLocalObject(UInt32 oObject, String sVarName)
        {
            ScriptHost.ExecuteActionService_268_2_DeleteLocalObject(oObject, sVarName);
        }

        public void DeleteLocalLocation(UInt32 oObject, String sVarName)
        {
            ScriptHost.ExecuteActionService_269_2_DeleteLocalLocation(oObject, sVarName);
        }

        public NWEffect EffectHaste()
        {
            return ScriptHost.ExecuteActionService_270_0_EffectHaste();
        }

        public NWEffect EffectSlow()
        {
            return ScriptHost.ExecuteActionService_271_0_EffectSlow();
        }

        public String ObjectToString(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_272_1_ObjectToString(oObject);
        }

        public NWEffect EffectImmunity(Int32 nImmunityType)
        {
            return ScriptHost.ExecuteActionService_273_1_EffectImmunity(nImmunityType);
        }

        public Int32 GetIsImmune(UInt32 oCreature, Int32 nImmunityType, UInt32 oVersus)
        {
            return ScriptHost.ExecuteActionService_274_3_GetIsImmune(oCreature, nImmunityType, oVersus);
        }

        public NWEffect EffectDamageImmunityIncrease(Int32 nDamageType, Int32 nPercentImmunity)
        {
            return ScriptHost.ExecuteActionService_275_2_EffectDamageImmunityIncrease(nDamageType, nPercentImmunity);
        }

        public Int32 GetEncounterActive(UInt32 oEncounter)
        {
            return ScriptHost.ExecuteActionService_276_1_GetEncounterActive(oEncounter);
        }

        public void SetEncounterActive(Int32 nNewValue, UInt32 oEncounter)
        {
            ScriptHost.ExecuteActionService_277_2_SetEncounterActive(nNewValue, oEncounter);
        }

        public Int32 GetEncounterSpawnsMax(UInt32 oEncounter)
        {
            return ScriptHost.ExecuteActionService_278_1_GetEncounterSpawnsMax(oEncounter);
        }

        public void SetEncounterSpawnsMax(Int32 nNewValue, UInt32 oEncounter)
        {
            ScriptHost.ExecuteActionService_279_2_SetEncounterSpawnsMax(nNewValue, oEncounter);
        }

        public Int32 GetEncounterSpawnsCurrent(UInt32 oEncounter)
        {
            return ScriptHost.ExecuteActionService_280_1_GetEncounterSpawnsCurrent(oEncounter);
        }

        public void SetEncounterSpawnsCurrent(Int32 nNewValue, UInt32 oEncounter)
        {
            ScriptHost.ExecuteActionService_281_2_SetEncounterSpawnsCurrent(nNewValue, oEncounter);
        }

        public UInt32 GetModuleItemAcquired()
        {
            return ScriptHost.ExecuteActionService_282_0_GetModuleItemAcquired();
        }

        public UInt32 GetModuleItemAcquiredFrom()
        {
            return ScriptHost.ExecuteActionService_283_0_GetModuleItemAcquiredFrom();
        }

        public void SetCustomToken(Int32 nCustomTokenNumber, String sTokenValue)
        {
            ScriptHost.ExecuteActionService_284_2_SetCustomToken(nCustomTokenNumber, sTokenValue);
        }

        public Int32 GetHasFeat(Int32 nFeat, UInt32 oCreature, Int32 nIgnoreUses)
        {
            return ScriptHost.ExecuteActionService_285_3_GetHasFeat(nFeat, oCreature, nIgnoreUses);
        }

        public Int32 GetHasSkill(Int32 nSkill, UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_286_2_GetHasSkill(nSkill, oCreature);
        }

        public void ActionUseFeat(Int32 nFeat, UInt32 oTarget)
        {
            ScriptHost.ExecuteActionService_287_2_ActionUseFeat(nFeat, oTarget);
        }

        public Int32 ActionUseSkill(Int32 nSkill, UInt32 oTarget, Int32 nSubSkill, UInt32 oItemUsed)
        {
            return ScriptHost.ExecuteActionService_288_4_ActionUseSkill(nSkill, oTarget, nSubSkill, oItemUsed);
        }

        public Int32 GetObjectSeen(UInt32 oTarget, UInt32 oSource)
        {
            return ScriptHost.ExecuteActionService_289_2_GetObjectSeen(oTarget, oSource);
        }

        public Int32 GetObjectHeard(UInt32 oTarget, UInt32 oSource)
        {
            return ScriptHost.ExecuteActionService_290_2_GetObjectHeard(oTarget, oSource);
        }

        public UInt32 GetLastPlayerDied()
        {
            return ScriptHost.ExecuteActionService_291_0_GetLastPlayerDied();
        }

        public UInt32 GetModuleItemLost()
        {
            return ScriptHost.ExecuteActionService_292_0_GetModuleItemLost();
        }

        public UInt32 GetModuleItemLostBy()
        {
            return ScriptHost.ExecuteActionService_293_0_GetModuleItemLostBy();
        }

        public void ActionDoCommand(NWAction aActionToDo)
        {
            InternalSaveStateForAction(aActionToDo);
            ScriptHost.ExecuteActionService_294_0_ActionDoCommand();
        }

        public NWEvent EventConversation()
        {
            return ScriptHost.ExecuteActionService_295_0_EventConversation();
        }

        public void SetEncounterDifficulty(Int32 nEncounterDifficulty, UInt32 oEncounter)
        {
            ScriptHost.ExecuteActionService_296_2_SetEncounterDifficulty(nEncounterDifficulty, oEncounter);
        }

        public Int32 GetEncounterDifficulty(UInt32 oEncounter)
        {
            return ScriptHost.ExecuteActionService_297_1_GetEncounterDifficulty(oEncounter);
        }

        public float GetDistanceBetweenLocations(NWLocation lLocationA, NWLocation lLocationB)
        {
            return ScriptHost.ExecuteActionService_298_2_GetDistanceBetweenLocations(lLocationA, lLocationB);
        }

        public Int32 GetReflexAdjustedDamage(Int32 nDamage, UInt32 oTarget, Int32 nDC, Int32 nSaveType, UInt32 oSaveVersus)
        {
            return ScriptHost.ExecuteActionService_299_5_GetReflexAdjustedDamage(nDamage, oTarget, nDC, nSaveType, oSaveVersus);
        }

        public void PlayAnimation(Int32 nAnimation, float fSpeed, float fSeconds)
        {
            ScriptHost.ExecuteActionService_300_3_PlayAnimation(nAnimation, (Single)fSpeed, (Single)fSeconds);
        }

        public NWTalent TalentSpell(Int32 nSpell)
        {
            return ScriptHost.ExecuteActionService_301_1_TalentSpell(nSpell);
        }

        public NWTalent TalentFeat(Int32 nFeat)
        {
            return ScriptHost.ExecuteActionService_302_1_TalentFeat(nFeat);
        }

        public NWTalent TalentSkill(Int32 nSkill)
        {
            return ScriptHost.ExecuteActionService_303_1_TalentSkill(nSkill);
        }

        public Int32 GetHasSpellEffect(Int32 nSpell, UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_304_2_GetHasSpellEffect(nSpell, oObject);
        }

        public Int32 GetEffectSpellId(NWEffect eSpellEffect)
        {
            return ScriptHost.ExecuteActionService_305_1_GetEffectSpellId(eSpellEffect);
        }

        public Int32 GetCreatureHasTalent(NWTalent tTalent, UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_306_2_GetCreatureHasTalent(tTalent, oCreature);
        }

        public NWTalent GetCreatureTalentRandom(Int32 nCategory, UInt32 oCreature, Int32 iExcludedTalentsFlag)
        {
            return ScriptHost.ExecuteActionService_307_3_GetCreatureTalentRandom(nCategory, oCreature, iExcludedTalentsFlag);
        }

        public NWTalent GetCreatureTalentBest(Int32 nCategory, Int32 nCRMax, UInt32 oCreature, Int32 iExcludedTalentsFlag)
        {
            return ScriptHost.ExecuteActionService_308_4_GetCreatureTalentBest(nCategory, nCRMax, oCreature, iExcludedTalentsFlag);
        }

        public void ActionUseTalentOnObject(NWTalent tChosenTalent, UInt32 oTarget)
        {
            ScriptHost.ExecuteActionService_309_2_ActionUseTalentOnObject(tChosenTalent, oTarget);
        }

        public void ActionUseTalentAtLocation(NWTalent tChosenTalent, NWLocation lTargetLocation)
        {
            ScriptHost.ExecuteActionService_310_2_ActionUseTalentAtLocation(tChosenTalent, lTargetLocation);
        }

        public Int32 GetGoldPieceValue(UInt32 oItem)
        {
            return ScriptHost.ExecuteActionService_311_1_GetGoldPieceValue(oItem);
        }

        public Int32 GetIsPlayableRacialType(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_312_1_GetIsPlayableRacialType(oCreature);
        }

        public void JumpToLocation(NWLocation lDestination)
        {
            ScriptHost.ExecuteActionService_313_1_JumpToLocation(lDestination);
        }

        public NWEffect EffectTemporaryHitpoints(Int32 nHitPoints)
        {
            return ScriptHost.ExecuteActionService_314_1_EffectTemporaryHitpoints(nHitPoints);
        }

        public Int32 GetSkillRank(Int32 nSkill, UInt32 oTarget, Int32 bBaseOnly)
        {
            return ScriptHost.ExecuteActionService_315_3_GetSkillRank(nSkill, oTarget, bBaseOnly);
        }

        public UInt32 GetAttackTarget(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_316_1_GetAttackTarget(oCreature);
        }

        public Int32 GetLastAttackType(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_317_1_GetLastAttackType(oCreature);
        }

        public Int32 GetLastAttackMode(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_318_1_GetLastAttackMode(oCreature);
        }

        public UInt32 GetMaster(UInt32 oAssociate)
        {
            return ScriptHost.ExecuteActionService_319_1_GetMaster(oAssociate);
        }

        public Int32 GetIsInCombat(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_320_1_GetIsInCombat(oCreature);
        }

        public Int32 GetLastAssociateCommand(UInt32 oAssociate)
        {
            return ScriptHost.ExecuteActionService_321_1_GetLastAssociateCommand(oAssociate);
        }

        public void GiveGoldToCreature(UInt32 oCreature, Int32 nGP, Int32 bDisplayFeedback)
        {
            ScriptHost.ExecuteActionService_322_3_GiveGoldToCreature(oCreature, nGP, bDisplayFeedback);
        }

        public void SetIsDestroyable(Int32 bDestroyable, Int32 bRaiseable, Int32 bSelectableWhenDead)
        {
            ScriptHost.ExecuteActionService_323_3_SetIsDestroyable(bDestroyable, bRaiseable, bSelectableWhenDead);
        }

        public void SetLocked(UInt32 oTarget, Int32 bLocked)
        {
            ScriptHost.ExecuteActionService_324_2_SetLocked(oTarget, bLocked);
        }

        public Int32 GetLocked(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_325_1_GetLocked(oTarget);
        }

        public UInt32 GetClickingObject()
        {
            return ScriptHost.ExecuteActionService_326_0_GetClickingObject();
        }

        public void SetAssociateListenPatterns(UInt32 oTarget)
        {
            ScriptHost.ExecuteActionService_327_1_SetAssociateListenPatterns(oTarget);
        }

        public UInt32 GetLastWeaponUsed(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_328_1_GetLastWeaponUsed(oCreature);
        }

        public void ActionInteractObject(UInt32 oPlaceable)
        {
            ScriptHost.ExecuteActionService_329_1_ActionInteractObject(oPlaceable);
        }

        public UInt32 GetLastUsedBy()
        {
            return ScriptHost.ExecuteActionService_330_0_GetLastUsedBy();
        }

        public Int32 GetAbilityModifier(Int32 nAbility, UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_331_2_GetAbilityModifier(nAbility, oCreature);
        }

        public Int32 GetIdentified(UInt32 oItem)
        {
            return ScriptHost.ExecuteActionService_332_1_GetIdentified(oItem);
        }

        public void SetIdentified(UInt32 oItem, Int32 bIdentified)
        {
            ScriptHost.ExecuteActionService_333_2_SetIdentified(oItem, bIdentified);
        }

        public void SummonAnimalCompanion(UInt32 oMaster, String sResRef)
        {
            ScriptHost.ExecuteActionService_334_2_SummonAnimalCompanion(oMaster, sResRef);
        }

        public void SummonFamiliar(UInt32 oMaster, String sResRef)
        {
            ScriptHost.ExecuteActionService_335_2_SummonFamiliar(oMaster, sResRef);
        }

        public UInt32 GetBlockingDoor()
        {
            return ScriptHost.ExecuteActionService_336_0_GetBlockingDoor();
        }

        public Int32 GetIsDoorActionPossible(UInt32 oTargetDoor, Int32 nDoorAction)
        {
            return ScriptHost.ExecuteActionService_337_2_GetIsDoorActionPossible(oTargetDoor, nDoorAction);
        }

        public void DoDoorAction(UInt32 oTargetDoor, Int32 nDoorAction)
        {
            ScriptHost.ExecuteActionService_338_2_DoDoorAction(oTargetDoor, nDoorAction);
        }

        public UInt32 GetFirstItemInInventory(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_339_1_GetFirstItemInInventory(oTarget);
        }

        public UInt32 GetNextItemInInventory(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_340_1_GetNextItemInInventory(oTarget);
        }

        public Int32 GetClassByPosition(Int32 nClassPosition, UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_341_2_GetClassByPosition(nClassPosition, oCreature);
        }

        public Int32 GetLevelByPosition(Int32 nClassPosition, UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_342_2_GetLevelByPosition(nClassPosition, oCreature);
        }

        public Int32 GetLevelByClass(Int32 nClassType, UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_343_2_GetLevelByClass(nClassType, oCreature);
        }

        public Int32 GetDamageDealtByType(Int32 nDamageType)
        {
            return ScriptHost.ExecuteActionService_344_1_GetDamageDealtByType(nDamageType);
        }

        public Int32 GetTotalDamageDealt()
        {
            return ScriptHost.ExecuteActionService_345_0_GetTotalDamageDealt();
        }

        public UInt32 GetLastDamager(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_346_1_GetLastDamager(oObject);
        }

        public UInt32 GetLastDisarmed()
        {
            return ScriptHost.ExecuteActionService_347_0_GetLastDisarmed();
        }

        public UInt32 GetLastDisturbed()
        {
            return ScriptHost.ExecuteActionService_348_0_GetLastDisturbed();
        }

        public UInt32 GetLastLocked()
        {
            return ScriptHost.ExecuteActionService_349_0_GetLastLocked();
        }

        public UInt32 GetLastUnlocked()
        {
            return ScriptHost.ExecuteActionService_350_0_GetLastUnlocked();
        }

        public NWEffect EffectSkillIncrease(Int32 nSkill, Int32 nValue)
        {
            return ScriptHost.ExecuteActionService_351_2_EffectSkillIncrease(nSkill, nValue);
        }

        public Int32 GetInventoryDisturbType()
        {
            return ScriptHost.ExecuteActionService_352_0_GetInventoryDisturbType();
        }

        public UInt32 GetInventoryDisturbItem()
        {
            return ScriptHost.ExecuteActionService_353_0_GetInventoryDisturbItem();
        }

        public UInt32 GetHenchman(UInt32 oMaster, Int32 nNth)
        {
            return ScriptHost.ExecuteActionService_354_2_GetHenchman(oMaster, nNth);
        }

        public NWEffect VersusAlignmentEffect(NWEffect eEffect, Int32 nLawChaos, Int32 nGoodEvil)
        {
            return ScriptHost.ExecuteActionService_355_3_VersusAlignmentEffect(eEffect, nLawChaos, nGoodEvil);
        }

        public NWEffect VersusRacialTypeEffect(NWEffect eEffect, Int32 nRacialType)
        {
            return ScriptHost.ExecuteActionService_356_2_VersusRacialTypeEffect(eEffect, nRacialType);
        }

        public NWEffect VersusTrapEffect(NWEffect eEffect)
        {
            return ScriptHost.ExecuteActionService_357_1_VersusTrapEffect(eEffect);
        }

        public Int32 GetGender(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_358_1_GetGender(oCreature);
        }

        public Int32 GetIsTalentValid(NWTalent tTalent)
        {
            return ScriptHost.ExecuteActionService_359_1_GetIsTalentValid(tTalent);
        }

        public void ActionMoveAwayFromLocation(NWLocation lMoveAwayFrom, Int32 bRun, float fMoveAwayRange)
        {
            ScriptHost.ExecuteActionService_360_3_ActionMoveAwayFromLocation(lMoveAwayFrom, bRun, (Single)fMoveAwayRange);
        }

        public UInt32 GetAttemptedAttackTarget()
        {
            return ScriptHost.ExecuteActionService_361_0_GetAttemptedAttackTarget();
        }

        public Int32 GetTypeFromTalent(NWTalent tTalent)
        {
            return ScriptHost.ExecuteActionService_362_1_GetTypeFromTalent(tTalent);
        }

        public Int32 GetIdFromTalent(NWTalent tTalent)
        {
            return ScriptHost.ExecuteActionService_363_1_GetIdFromTalent(tTalent);
        }

        public UInt32 GetAssociate(Int32 nAssociateType, UInt32 oMaster, Int32 nTh)
        {
            return ScriptHost.ExecuteActionService_364_3_GetAssociate(nAssociateType, oMaster, nTh);
        }

        public void AddHenchman(UInt32 oMaster, UInt32 oHenchman)
        {
            ScriptHost.ExecuteActionService_365_2_AddHenchman(oMaster, oHenchman);
        }

        public void RemoveHenchman(UInt32 oMaster, UInt32 oHenchman)
        {
            ScriptHost.ExecuteActionService_366_2_RemoveHenchman(oMaster, oHenchman);
        }

        public void AddJournalQuestEntry(String szPlotID, Int32 nState, UInt32 oCreature, Int32 bAllPartyMembers, Int32 bAllPlayers, Int32 bAllowOverrideHigher)
        {
            ScriptHost.ExecuteActionService_367_6_AddJournalQuestEntry(szPlotID, nState, oCreature, bAllPartyMembers, bAllPlayers, bAllowOverrideHigher);
        }

        public void RemoveJournalQuestEntry(String szPlotID, UInt32 oCreature, Int32 bAllPartyMembers, Int32 bAllPlayers)
        {
            ScriptHost.ExecuteActionService_368_4_RemoveJournalQuestEntry(szPlotID, oCreature, bAllPartyMembers, bAllPlayers);
        }

        public String GetPCPublicCDKey(UInt32 oPlayer)
        {
            return ScriptHost.ExecuteActionService_369_1_GetPCPublicCDKey(oPlayer);
        }

        public String GetPCIPAddress(UInt32 oPlayer)
        {
            return ScriptHost.ExecuteActionService_370_1_GetPCIPAddress(oPlayer);
        }

        public String GetPCPlayerName(UInt32 oPlayer)
        {
            return ScriptHost.ExecuteActionService_371_1_GetPCPlayerName(oPlayer);
        }

        public void SetPCLike(UInt32 oPlayer, UInt32 oTarget)
        {
            ScriptHost.ExecuteActionService_372_2_SetPCLike(oPlayer, oTarget);
        }

        public void SetPCDislike(UInt32 oPlayer, UInt32 oTarget)
        {
            ScriptHost.ExecuteActionService_373_2_SetPCDislike(oPlayer, oTarget);
        }

        public void SendMessageToPC(UInt32 oPlayer, String szMessage)
        {
            ScriptHost.ExecuteActionService_374_2_SendMessageToPC(oPlayer, szMessage);
        }

        public UInt32 GetAttemptedSpellTarget()
        {
            return ScriptHost.ExecuteActionService_375_0_GetAttemptedSpellTarget();
        }

        public UInt32 GetLastOpenedBy()
        {
            return ScriptHost.ExecuteActionService_376_0_GetLastOpenedBy();
        }

        public Int32 GetHasSpell(Int32 nSpell, UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_377_2_GetHasSpell(nSpell, oCreature);
        }

        public void OpenStore(UInt32 oStore, UInt32 oPC, Int32 nBonusMarkUp, Int32 nBonusMarkDown)
        {
            ScriptHost.ExecuteActionService_378_4_OpenStore(oStore, oPC, nBonusMarkUp, nBonusMarkDown);
        }

        public NWEffect EffectTurned()
        {
            return ScriptHost.ExecuteActionService_379_0_EffectTurned();
        }

        public UInt32 GetFirstFactionMember(UInt32 oMemberOfFaction, Int32 bPCOnly)
        {
            return ScriptHost.ExecuteActionService_380_2_GetFirstFactionMember(oMemberOfFaction, bPCOnly);
        }

        public UInt32 GetNextFactionMember(UInt32 oMemberOfFaction, Int32 bPCOnly)
        {
            return ScriptHost.ExecuteActionService_381_2_GetNextFactionMember(oMemberOfFaction, bPCOnly);
        }

        public void ActionForceMoveToLocation(NWLocation lDestination, Int32 bRun, float fTimeout)
        {
            ScriptHost.ExecuteActionService_382_3_ActionForceMoveToLocation(lDestination, bRun, (Single)fTimeout);
        }

        public void ActionForceMoveToObject(UInt32 oMoveTo, Int32 bRun, float fRange, float fTimeout)
        {
            ScriptHost.ExecuteActionService_383_4_ActionForceMoveToObject(oMoveTo, bRun, (Single)fRange, (Single)fTimeout);
        }

        public Int32 GetJournalQuestExperience(String szPlotID)
        {
            return ScriptHost.ExecuteActionService_384_1_GetJournalQuestExperience(szPlotID);
        }

        public void JumpToObject(UInt32 oToJumpTo, Int32 nWalkStraightLineToPoint)
        {
            ScriptHost.ExecuteActionService_385_2_JumpToObject(oToJumpTo, nWalkStraightLineToPoint);
        }

        public void SetMapPinEnabled(UInt32 oMapPin, Int32 nEnabled)
        {
            ScriptHost.ExecuteActionService_386_2_SetMapPinEnabled(oMapPin, nEnabled);
        }

        public NWEffect EffectHitPointChangeWhenDying(float fHitPointChangePerRound)
        {
            return ScriptHost.ExecuteActionService_387_1_EffectHitPointChangeWhenDying((Single)fHitPointChangePerRound);
        }

        public void PopUpGUIPanel(UInt32 oPC, Int32 nGUIPanel)
        {
            ScriptHost.ExecuteActionService_388_2_PopUpGUIPanel(oPC, nGUIPanel);
        }

        public void ClearPersonalReputation(UInt32 oTarget, UInt32 oSource)
        {
            ScriptHost.ExecuteActionService_389_2_ClearPersonalReputation(oTarget, oSource);
        }

        public void SetIsTemporaryFriend(UInt32 oTarget, UInt32 oSource, Int32 bDecays, float fDurationInSeconds)
        {
            ScriptHost.ExecuteActionService_390_4_SetIsTemporaryFriend(oTarget, oSource, bDecays, (Single)fDurationInSeconds);
        }

        public void SetIsTemporaryEnemy(UInt32 oTarget, UInt32 oSource, Int32 bDecays, float fDurationInSeconds)
        {
            ScriptHost.ExecuteActionService_391_4_SetIsTemporaryEnemy(oTarget, oSource, bDecays, (Single)fDurationInSeconds);
        }

        public void SetIsTemporaryNeutral(UInt32 oTarget, UInt32 oSource, Int32 bDecays, float fDurationInSeconds)
        {
            ScriptHost.ExecuteActionService_392_4_SetIsTemporaryNeutral(oTarget, oSource, bDecays, (Single)fDurationInSeconds);
        }

        public void GiveXPToCreature(UInt32 oCreature, Int32 nXpAmount)
        {
            ScriptHost.ExecuteActionService_393_2_GiveXPToCreature(oCreature, nXpAmount);
        }

        public void SetXP(UInt32 oCreature, Int32 nXpAmount)
        {
            ScriptHost.ExecuteActionService_394_2_SetXP(oCreature, nXpAmount);
        }

        public Int32 GetXP(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_395_1_GetXP(oCreature);
        }

        public String IntToHexString(Int32 nInteger)
        {
            return ScriptHost.ExecuteActionService_396_1_IntToHexString(nInteger);
        }

        public Int32 GetBaseItemType(UInt32 oItem)
        {
            return ScriptHost.ExecuteActionService_397_1_GetBaseItemType(oItem);
        }

        public Int32 GetItemHasItemProperty(UInt32 oItem, Int32 nProperty)
        {
            return ScriptHost.ExecuteActionService_398_2_GetItemHasItemProperty(oItem, nProperty);
        }

        public void ActionEquipMostDamagingMelee(UInt32 oVersus, Int32 bOffHand)
        {
            ScriptHost.ExecuteActionService_399_2_ActionEquipMostDamagingMelee(oVersus, bOffHand);
        }

        public void ActionEquipMostDamagingRanged(UInt32 oVersus)
        {
            ScriptHost.ExecuteActionService_400_1_ActionEquipMostDamagingRanged(oVersus);
        }

        public Int32 GetItemACValue(UInt32 oItem)
        {
            return ScriptHost.ExecuteActionService_401_1_GetItemACValue(oItem);
        }

        public void ActionRest(Int32 bIgnoreNoRestFlag)
        {
            ScriptHost.ExecuteActionService_402_1_ActionRest(bIgnoreNoRestFlag);
        }

        public void ExploreAreaForPlayer(UInt32 oArea, UInt32 oPlayer, Int32 nExplored)
        {
            ScriptHost.ExecuteActionService_403_3_ExploreAreaForPlayer(oArea, oPlayer, nExplored);
        }

        public void ActionEquipMostEffectiveArmor()
        {
            ScriptHost.ExecuteActionService_404_0_ActionEquipMostEffectiveArmor();
        }

        public Int32 GetIsDay()
        {
            return ScriptHost.ExecuteActionService_405_0_GetIsDay();
        }

        public Int32 GetIsNight()
        {
            return ScriptHost.ExecuteActionService_406_0_GetIsNight();
        }

        public Int32 GetIsDawn()
        {
            return ScriptHost.ExecuteActionService_407_0_GetIsDawn();
        }

        public Int32 GetIsDusk()
        {
            return ScriptHost.ExecuteActionService_408_0_GetIsDusk();
        }

        public Int32 GetIsEncounterCreature(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_409_1_GetIsEncounterCreature(oCreature);
        }

        public UInt32 GetLastPlayerDying()
        {
            return ScriptHost.ExecuteActionService_410_0_GetLastPlayerDying();
        }

        public NWLocation GetStartingLocation()
        {
            return ScriptHost.ExecuteActionService_411_0_GetStartingLocation();
        }

        public void ChangeToStandardFaction(UInt32 oCreatureToChange, Int32 nStandardFaction)
        {
            ScriptHost.ExecuteActionService_412_2_ChangeToStandardFaction(oCreatureToChange, nStandardFaction);
        }

        public void SoundObjectPlay(UInt32 oSound)
        {
            ScriptHost.ExecuteActionService_413_1_SoundObjectPlay(oSound);
        }

        public void SoundObjectStop(UInt32 oSound)
        {
            ScriptHost.ExecuteActionService_414_1_SoundObjectStop(oSound);
        }

        public void SoundObjectSetVolume(UInt32 oSound, Int32 nVolume)
        {
            ScriptHost.ExecuteActionService_415_2_SoundObjectSetVolume(oSound, nVolume);
        }

        public void SoundObjectSetPosition(UInt32 oSound, NWScript.Vector3 vPosition)
        {
            ScriptHost.ExecuteActionService_416_4_SoundObjectSetPosition(oSound, vPosition.z, vPosition.y, vPosition.x);
        }

        public void SpeakOneLinerConversation(String sDialogResRef, UInt32 oTokenTarget, Int32 nTalkVolume)
        {
            ScriptHost.ExecuteActionService_417_3_SpeakOneLinerConversation(sDialogResRef, oTokenTarget, nTalkVolume);
        }

        public Int32 GetGold(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_418_1_GetGold(oTarget);
        }

        public UInt32 GetLastRespawnButtonPresser()
        {
            return ScriptHost.ExecuteActionService_419_0_GetLastRespawnButtonPresser();
        }

        public Int32 GetIsDM(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_420_1_GetIsDM(oCreature);
        }

        public void PlayVoiceChat(Int32 nVoiceChatID, UInt32 oTarget)
        {
            ScriptHost.ExecuteActionService_421_2_PlayVoiceChat(nVoiceChatID, oTarget);
        }

        public Int32 GetIsWeaponEffective(UInt32 oVersus, Int32 bOffHand)
        {
            return ScriptHost.ExecuteActionService_422_2_GetIsWeaponEffective(oVersus, bOffHand);
        }

        public Int32 GetLastSpellHarmful()
        {
            return ScriptHost.ExecuteActionService_423_0_GetLastSpellHarmful();
        }

        public NWEvent EventActivateItem(UInt32 oItem, NWLocation lTarget, UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_424_3_EventActivateItem(oItem, lTarget, oTarget);
        }

        public void MusicBackgroundPlay(UInt32 oArea)
        {
            ScriptHost.ExecuteActionService_425_1_MusicBackgroundPlay(oArea);
        }

        public void MusicBackgroundStop(UInt32 oArea)
        {
            ScriptHost.ExecuteActionService_426_1_MusicBackgroundStop(oArea);
        }

        public void MusicBackgroundSetDelay(UInt32 oArea, Int32 nDelay)
        {
            ScriptHost.ExecuteActionService_427_2_MusicBackgroundSetDelay(oArea, nDelay);
        }

        public void MusicBackgroundChangeDay(UInt32 oArea, Int32 nTrack)
        {
            ScriptHost.ExecuteActionService_428_2_MusicBackgroundChangeDay(oArea, nTrack);
        }

        public void MusicBackgroundChangeNight(UInt32 oArea, Int32 nTrack)
        {
            ScriptHost.ExecuteActionService_429_2_MusicBackgroundChangeNight(oArea, nTrack);
        }

        public void MusicBattlePlay(UInt32 oArea)
        {
            ScriptHost.ExecuteActionService_430_1_MusicBattlePlay(oArea);
        }

        public void MusicBattleStop(UInt32 oArea)
        {
            ScriptHost.ExecuteActionService_431_1_MusicBattleStop(oArea);
        }

        public void MusicBattleChange(UInt32 oArea, Int32 nTrack)
        {
            ScriptHost.ExecuteActionService_432_2_MusicBattleChange(oArea, nTrack);
        }

        public void AmbientSoundPlay(UInt32 oArea)
        {
            ScriptHost.ExecuteActionService_433_1_AmbientSoundPlay(oArea);
        }

        public void AmbientSoundStop(UInt32 oArea)
        {
            ScriptHost.ExecuteActionService_434_1_AmbientSoundStop(oArea);
        }

        public void AmbientSoundChangeDay(UInt32 oArea, Int32 nTrack)
        {
            ScriptHost.ExecuteActionService_435_2_AmbientSoundChangeDay(oArea, nTrack);
        }

        public void AmbientSoundChangeNight(UInt32 oArea, Int32 nTrack)
        {
            ScriptHost.ExecuteActionService_436_2_AmbientSoundChangeNight(oArea, nTrack);
        }

        public UInt32 GetLastKiller()
        {
            return ScriptHost.ExecuteActionService_437_0_GetLastKiller();
        }

        public UInt32 GetSpellCastItem()
        {
            return ScriptHost.ExecuteActionService_438_0_GetSpellCastItem();
        }

        public UInt32 GetItemActivated()
        {
            return ScriptHost.ExecuteActionService_439_0_GetItemActivated();
        }

        public UInt32 GetItemActivator()
        {
            return ScriptHost.ExecuteActionService_440_0_GetItemActivator();
        }

        public NWLocation GetItemActivatedTargetLocation()
        {
            return ScriptHost.ExecuteActionService_441_0_GetItemActivatedTargetLocation();
        }

        public UInt32 GetItemActivatedTarget()
        {
            return ScriptHost.ExecuteActionService_442_0_GetItemActivatedTarget();
        }

        public Int32 GetIsOpen(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_443_1_GetIsOpen(oObject);
        }

        public void TakeGoldFromCreature(Int32 nAmount, UInt32 oCreatureToTakeFrom, Int32 bDestroy, Int32 bDisplayFeedback)
        {
            ScriptHost.ExecuteActionService_444_4_TakeGoldFromCreature(nAmount, oCreatureToTakeFrom, bDestroy, bDisplayFeedback);
        }

        public Int32 IsInConversation(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_445_1_IsInConversation(oObject);
        }

        public NWEffect EffectAbilityDecrease(Int32 nAbility, Int32 nModifyBy)
        {
            return ScriptHost.ExecuteActionService_446_2_EffectAbilityDecrease(nAbility, nModifyBy);
        }

        public NWEffect EffectAttackDecrease(Int32 nPenalty, Int32 nModifierType)
        {
            return ScriptHost.ExecuteActionService_447_2_EffectAttackDecrease(nPenalty, nModifierType);
        }

        public NWEffect EffectDamageDecrease(Int32 nPenalty, Int32 nDamageType)
        {
            return ScriptHost.ExecuteActionService_448_2_EffectDamageDecrease(nPenalty, nDamageType);
        }

        public NWEffect EffectDamageImmunityDecrease(Int32 nDamageType, Int32 nPercentImmunity)
        {
            return ScriptHost.ExecuteActionService_449_2_EffectDamageImmunityDecrease(nDamageType, nPercentImmunity);
        }

        public NWEffect EffectACDecrease(Int32 nValue, Int32 nModifyType, Int32 nDamageType)
        {
            return ScriptHost.ExecuteActionService_450_3_EffectACDecrease(nValue, nModifyType, nDamageType);
        }

        public NWEffect EffectMovementSpeedDecrease(Int32 nPercentChange)
        {
            return ScriptHost.ExecuteActionService_451_1_EffectMovementSpeedDecrease(nPercentChange);
        }

        public NWEffect EffectSavingThrowDecrease(Int32 nSave, Int32 nValue, Int32 nSaveType)
        {
            return ScriptHost.ExecuteActionService_452_3_EffectSavingThrowDecrease(nSave, nValue, nSaveType);
        }

        public NWEffect EffectSkillDecrease(Int32 nSkill, Int32 nValue)
        {
            return ScriptHost.ExecuteActionService_453_2_EffectSkillDecrease(nSkill, nValue);
        }

        public NWEffect EffectSpellResistanceDecrease(Int32 nValue)
        {
            return ScriptHost.ExecuteActionService_454_1_EffectSpellResistanceDecrease(nValue);
        }

        public Int32 GetPlotFlag(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_455_1_GetPlotFlag(oTarget);
        }

        public void SetPlotFlag(UInt32 oTarget, Int32 nPlotFlag)
        {
            ScriptHost.ExecuteActionService_456_2_SetPlotFlag(oTarget, nPlotFlag);
        }

        public NWEffect EffectInvisibility(Int32 nInvisibilityType)
        {
            return ScriptHost.ExecuteActionService_457_1_EffectInvisibility(nInvisibilityType);
        }

        public NWEffect EffectConcealment(Int32 nPercentage, Int32 nMissType)
        {
            return ScriptHost.ExecuteActionService_458_2_EffectConcealment(nPercentage, nMissType);
        }

        public NWEffect EffectDarkness()
        {
            return ScriptHost.ExecuteActionService_459_0_EffectDarkness();
        }

        public NWEffect EffectDispelMagicAll(Int32 nCasterLevel, NWAction aOnDispelEffect)
        {
            InternalSaveStateForAction(aOnDispelEffect);
            return ScriptHost.ExecuteActionService_460_1_EffectDispelMagicAll(nCasterLevel);
        }

        public NWEffect EffectUltravision()
        {
            return ScriptHost.ExecuteActionService_461_0_EffectUltravision();
        }

        public NWEffect EffectNegativeLevel(Int32 nNumLevels, Int32 bHPBonus)
        {
            return ScriptHost.ExecuteActionService_462_2_EffectNegativeLevel(nNumLevels, bHPBonus);
        }

        public NWEffect EffectPolymorph(Int32 nPolymorphSelection, Int32 nLocked, Int32 bWildshape)
        {
            return ScriptHost.ExecuteActionService_463_3_EffectPolymorph(nPolymorphSelection, nLocked, bWildshape);
        }

        public NWEffect EffectSanctuary(Int32 nDifficultyClass)
        {
            return ScriptHost.ExecuteActionService_464_1_EffectSanctuary(nDifficultyClass);
        }

        public NWEffect EffectTrueSeeing()
        {
            return ScriptHost.ExecuteActionService_465_0_EffectTrueSeeing();
        }

        public NWEffect EffectSeeInvisible()
        {
            return ScriptHost.ExecuteActionService_466_0_EffectSeeInvisible();
        }

        public NWEffect EffectTimeStop()
        {
            return ScriptHost.ExecuteActionService_467_0_EffectTimeStop();
        }

        public NWEffect EffectBlindness()
        {
            return ScriptHost.ExecuteActionService_468_0_EffectBlindness();
        }

        public Int32 GetIsReactionTypeFriendly(UInt32 oTarget, UInt32 oSource)
        {
            return ScriptHost.ExecuteActionService_469_2_GetIsReactionTypeFriendly(oTarget, oSource);
        }

        public Int32 GetIsReactionTypeNeutral(UInt32 oTarget, UInt32 oSource)
        {
            return ScriptHost.ExecuteActionService_470_2_GetIsReactionTypeNeutral(oTarget, oSource);
        }

        public Int32 GetIsReactionTypeHostile(UInt32 oTarget, UInt32 oSource)
        {
            return ScriptHost.ExecuteActionService_471_2_GetIsReactionTypeHostile(oTarget, oSource);
        }

        public NWEffect EffectSpellLevelAbsorption(Int32 nMaxSpellLevelAbsorbed, Int32 nTotalSpellLevelsAbsorbed, Int32 nSpellSchool)
        {
            return ScriptHost.ExecuteActionService_472_3_EffectSpellLevelAbsorption(nMaxSpellLevelAbsorbed, nTotalSpellLevelsAbsorbed, nSpellSchool);
        }

        public NWEffect EffectDispelMagicBest(Int32 nCasterLevel, NWAction aOnDispelEffect)
        {
            InternalSaveStateForAction(aOnDispelEffect);
            return ScriptHost.ExecuteActionService_473_1_EffectDispelMagicBest(nCasterLevel);
        }

        public void ActivatePortal(UInt32 oTarget, String sIPaddress, String sPassword, String sWaypointTag, Int32 bSeemless)
        {
            ScriptHost.ExecuteActionService_474_5_ActivatePortal(oTarget, sIPaddress, sPassword, sWaypointTag, bSeemless);
        }

        public Int32 GetNumStackedItems(UInt32 oItem)
        {
            return ScriptHost.ExecuteActionService_475_1_GetNumStackedItems(oItem);
        }

        public void SurrenderToEnemies()
        {
            ScriptHost.ExecuteActionService_476_0_SurrenderToEnemies();
        }

        public NWEffect EffectMissChance(Int32 nPercentage, Int32 nMissChanceType)
        {
            return ScriptHost.ExecuteActionService_477_2_EffectMissChance(nPercentage, nMissChanceType);
        }

        public Int32 GetTurnResistanceHD(UInt32 oUndead)
        {
            return ScriptHost.ExecuteActionService_478_1_GetTurnResistanceHD(oUndead);
        }

        public Int32 GetCreatureSize(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_479_1_GetCreatureSize(oCreature);
        }

        public NWEffect EffectDisappearAppear(NWLocation lLocation, Int32 nAnimation)
        {
            return ScriptHost.ExecuteActionService_480_2_EffectDisappearAppear(lLocation, nAnimation);
        }

        public NWEffect EffectDisappear(Int32 nAnimation)
        {
            return ScriptHost.ExecuteActionService_481_1_EffectDisappear(nAnimation);
        }

        public NWEffect EffectAppear(Int32 nAnimation)
        {
            return ScriptHost.ExecuteActionService_482_1_EffectAppear(nAnimation);
        }

        public void ActionUnlockObject(UInt32 oTarget)
        {
            ScriptHost.ExecuteActionService_483_1_ActionUnlockObject(oTarget);
        }

        public void ActionLockObject(UInt32 oTarget)
        {
            ScriptHost.ExecuteActionService_484_1_ActionLockObject(oTarget);
        }

        public NWEffect EffectModifyAttacks(Int32 nAttacks)
        {
            return ScriptHost.ExecuteActionService_485_1_EffectModifyAttacks(nAttacks);
        }

        public UInt32 GetLastTrapDetected(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_486_1_GetLastTrapDetected(oTarget);
        }

        public NWEffect EffectDamageShield(Int32 nDamageAmount, Int32 nRandomAmount, Int32 nDamageType)
        {
            return ScriptHost.ExecuteActionService_487_3_EffectDamageShield(nDamageAmount, nRandomAmount, nDamageType);
        }

        public UInt32 GetNearestTrapToObject(UInt32 oTarget, Int32 nTrapDetected)
        {
            return ScriptHost.ExecuteActionService_488_2_GetNearestTrapToObject(oTarget, nTrapDetected);
        }

        public String GetDeity(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_489_1_GetDeity(oCreature);
        }

        public Int32 GetSubRace(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_490_1_GetSubRace(oTarget);
        }

        public Int32 GetFortitudeSavingThrow(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_491_1_GetFortitudeSavingThrow(oTarget);
        }

        public Int32 GetWillSavingThrow(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_492_1_GetWillSavingThrow(oTarget);
        }

        public Int32 GetReflexSavingThrow(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_493_1_GetReflexSavingThrow(oTarget);
        }

        public float GetChallengeRating(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_494_1_GetChallengeRating(oCreature);
        }

        public Int32 GetAge(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_495_1_GetAge(oCreature);
        }

        public Int32 GetMovementRate(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_496_1_GetMovementRate(oCreature);
        }

        public Int32 GetAnimalCompanionCreatureType(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_497_1_GetAnimalCompanionCreatureType(oCreature);
        }

        public Int32 GetFamiliarCreatureType(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_498_1_GetFamiliarCreatureType(oCreature);
        }

        public String GetAnimalCompanionName(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_499_1_GetAnimalCompanionName(oTarget);
        }

        public String GetFamiliarName(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_500_1_GetFamiliarName(oCreature);
        }

        public void ActionCastFakeSpellAtObject(Int32 nSpell, UInt32 oTarget, Int32 nProjectilePathType)
        {
            ScriptHost.ExecuteActionService_501_3_ActionCastFakeSpellAtObject(nSpell, oTarget, nProjectilePathType);
        }

        public void ActionCastFakeSpellAtLocation(Int32 nSpell, NWLocation lTarget, Int32 nProjectilePathType)
        {
            ScriptHost.ExecuteActionService_502_3_ActionCastFakeSpellAtLocation(nSpell, lTarget, nProjectilePathType);
        }

        public void RemoveSummonedAssociate(UInt32 oMaster, UInt32 oAssociate)
        {
            ScriptHost.ExecuteActionService_503_2_RemoveSummonedAssociate(oMaster, oAssociate);
        }

        public void SetCameraMode(UInt32 oPlayer, Int32 nCameraMode)
        {
            ScriptHost.ExecuteActionService_504_2_SetCameraMode(oPlayer, nCameraMode);
        }

        public Int32 GetIsResting(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_505_1_GetIsResting(oCreature);
        }

        public UInt32 GetLastPCRested()
        {
            return ScriptHost.ExecuteActionService_506_0_GetLastPCRested();
        }

        public void SetWeather(UInt32 oTarget, Int32 nWeatherType, Int32 nPower)
        {
            ScriptHost.ExecuteActionService_507_3_SetWeather(oTarget, nWeatherType, nPower);
        }

        public Int32 GetLastRestEventType()
        {
            return ScriptHost.ExecuteActionService_508_0_GetLastRestEventType();
        }

        public void StartNewModule(String sModuleName, String sWaypoint)
        {
            ScriptHost.ExecuteActionService_509_2_StartNewModule(sModuleName, sWaypoint);
        }

        public NWEffect EffectSwarm(Int32 nLooping, String sCreatureTemplate1, String sCreatureTemplate2, String sCreatureTemplate3, String sCreatureTemplate4)
        {
            return ScriptHost.ExecuteActionService_510_5_EffectSwarm(nLooping, sCreatureTemplate1, sCreatureTemplate2, sCreatureTemplate3, sCreatureTemplate4);
        }

        public Int32 GetWeaponRanged(UInt32 oItem)
        {
            return ScriptHost.ExecuteActionService_511_1_GetWeaponRanged(oItem);
        }

        public void DoSinglePlayerAutoSave()
        {
            ScriptHost.ExecuteActionService_512_0_DoSinglePlayerAutoSave();
        }

        public Int32 GetGameDifficulty()
        {
            return ScriptHost.ExecuteActionService_513_0_GetGameDifficulty();
        }

        public void SetTileMainLightColor(NWLocation lTileLocation, Int32 nMainLight1Color, Int32 nMainLight2Color)
        {
            ScriptHost.ExecuteActionService_514_3_SetTileMainLightColor(lTileLocation, nMainLight1Color, nMainLight2Color);
        }

        public void SetTileSourceLightColor(NWLocation lTileLocation, Int32 nSourceLight1Color, Int32 nSourceLight2Color)
        {
            ScriptHost.ExecuteActionService_515_3_SetTileSourceLightColor(lTileLocation, nSourceLight1Color, nSourceLight2Color);
        }

        public void RecomputeStaticLighting(UInt32 oArea)
        {
            ScriptHost.ExecuteActionService_516_1_RecomputeStaticLighting(oArea);
        }

        public Int32 GetTileMainLight1Color(NWLocation lTile)
        {
            return ScriptHost.ExecuteActionService_517_1_GetTileMainLight1Color(lTile);
        }

        public Int32 GetTileMainLight2Color(NWLocation lTile)
        {
            return ScriptHost.ExecuteActionService_518_1_GetTileMainLight2Color(lTile);
        }

        public Int32 GetTileSourceLight1Color(NWLocation lTile)
        {
            return ScriptHost.ExecuteActionService_519_1_GetTileSourceLight1Color(lTile);
        }

        public Int32 GetTileSourceLight2Color(NWLocation lTile)
        {
            return ScriptHost.ExecuteActionService_520_1_GetTileSourceLight2Color(lTile);
        }

        public void SetPanelButtonFlash(UInt32 oPlayer, Int32 nButton, Int32 nEnableFlash)
        {
            ScriptHost.ExecuteActionService_521_3_SetPanelButtonFlash(oPlayer, nButton, nEnableFlash);
        }

        public Int32 GetCurrentAction(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_522_1_GetCurrentAction(oObject);
        }

        public void SetStandardFactionReputation(Int32 nStandardFaction, Int32 nNewReputation, UInt32 oCreature)
        {
            ScriptHost.ExecuteActionService_523_3_SetStandardFactionReputation(nStandardFaction, nNewReputation, oCreature);
        }

        public Int32 GetStandardFactionReputation(Int32 nStandardFaction, UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_524_2_GetStandardFactionReputation(nStandardFaction, oCreature);
        }

        public void FloatingTextStrRefOnCreature(Int32 nStrRefToDisplay, UInt32 oCreatureToFloatAbove, Int32 bBroadcastToFaction, float fDuration, Int32 nStartColor, Int32 nEndColor, float fSpeed, NWScript.Vector3 vDirection)
        {
            ScriptHost.ExecuteActionService_525_10_FloatingTextStrRefOnCreature(nStrRefToDisplay, oCreatureToFloatAbove, bBroadcastToFaction, (Single)fDuration, nStartColor, nEndColor, (Single)fSpeed, vDirection.z, vDirection.y, vDirection.x);
        }

        public void FloatingTextStringOnCreature(String sStringToDisplay, UInt32 oCreatureToFloatAbove, Int32 bBroadcastToFaction, float fDuration, Int32 nStartColor, Int32 nEndColor, float fSpeed, NWScript.Vector3 vDirection)
        {
            ScriptHost.ExecuteActionService_526_10_FloatingTextStringOnCreature(sStringToDisplay, oCreatureToFloatAbove, bBroadcastToFaction, (Single)fDuration, nStartColor, nEndColor, (Single)fSpeed, vDirection.z, vDirection.y, vDirection.x);
        }

        public Int32 GetTrapDisarmable(UInt32 oTrapObject)
        {
            return ScriptHost.ExecuteActionService_527_1_GetTrapDisarmable(oTrapObject);
        }

        public Int32 GetTrapDetectable(UInt32 oTrapObject)
        {
            return ScriptHost.ExecuteActionService_528_1_GetTrapDetectable(oTrapObject);
        }

        public Int32 GetTrapDetectedBy(UInt32 oTrapObject, UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_529_2_GetTrapDetectedBy(oTrapObject, oCreature);
        }

        public Int32 GetTrapFlagged(UInt32 oTrapObject)
        {
            return ScriptHost.ExecuteActionService_530_1_GetTrapFlagged(oTrapObject);
        }

        public Int32 GetTrapBaseType(UInt32 oTrapObject)
        {
            return ScriptHost.ExecuteActionService_531_1_GetTrapBaseType(oTrapObject);
        }

        public Int32 GetTrapOneShot(UInt32 oTrapObject)
        {
            return ScriptHost.ExecuteActionService_532_1_GetTrapOneShot(oTrapObject);
        }

        public UInt32 GetTrapCreator(UInt32 oTrapObject)
        {
            return ScriptHost.ExecuteActionService_533_1_GetTrapCreator(oTrapObject);
        }

        public String GetTrapKeyTag(UInt32 oTrapObject)
        {
            return ScriptHost.ExecuteActionService_534_1_GetTrapKeyTag(oTrapObject);
        }

        public Int32 GetTrapDisarmDC(UInt32 oTrapObject)
        {
            return ScriptHost.ExecuteActionService_535_1_GetTrapDisarmDC(oTrapObject);
        }

        public Int32 GetTrapDetectDC(UInt32 oTrapObject)
        {
            return ScriptHost.ExecuteActionService_536_1_GetTrapDetectDC(oTrapObject);
        }

        public Int32 GetLockKeyRequired(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_537_1_GetLockKeyRequired(oObject);
        }

        public String GetLockKeyTag(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_538_1_GetLockKeyTag(oObject);
        }

        public Int32 GetLockLockable(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_539_1_GetLockLockable(oObject);
        }

        public Int32 GetLockUnlockDC(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_540_1_GetLockUnlockDC(oObject);
        }

        public Int32 GetLockLockDC(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_541_1_GetLockLockDC(oObject);
        }

        public UInt32 GetPCLevellingUp()
        {
            return ScriptHost.ExecuteActionService_542_0_GetPCLevellingUp();
        }

        public Int32 GetHasFeatEffect(Int32 nFeat, UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_543_2_GetHasFeatEffect(nFeat, oObject);
        }

        public void SetPlaceableIllumination(UInt32 oPlaceable, Int32 bIlluminate)
        {
            ScriptHost.ExecuteActionService_544_2_SetPlaceableIllumination(oPlaceable, bIlluminate);
        }

        public Int32 GetPlaceableIllumination(UInt32 oPlaceable)
        {
            return ScriptHost.ExecuteActionService_545_1_GetPlaceableIllumination(oPlaceable);
        }

        public Int32 GetIsPlaceableObjectActionPossible(UInt32 oPlaceable, Int32 nPlaceableAction)
        {
            return ScriptHost.ExecuteActionService_546_2_GetIsPlaceableObjectActionPossible(oPlaceable, nPlaceableAction);
        }

        public void DoPlaceableObjectAction(UInt32 oPlaceable, Int32 nPlaceableAction)
        {
            ScriptHost.ExecuteActionService_547_2_DoPlaceableObjectAction(oPlaceable, nPlaceableAction);
        }

        public UInt32 GetFirstPC(Int32 bOwnedCharacter)
        {
            return ScriptHost.ExecuteActionService_548_1_GetFirstPC(bOwnedCharacter);
        }

        public UInt32 GetNextPC(Int32 bOwnedCharacter)
        {
            return ScriptHost.ExecuteActionService_549_1_GetNextPC(bOwnedCharacter);
        }

        public Int32 SetTrapDetectedBy(UInt32 oTrap, UInt32 oDetector)
        {
            return ScriptHost.ExecuteActionService_550_2_SetTrapDetectedBy(oTrap, oDetector);
        }

        public Int32 GetIsTrapped(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_551_1_GetIsTrapped(oObject);
        }

        public NWEffect EffectTurnResistanceDecrease(Int32 nHitDice)
        {
            return ScriptHost.ExecuteActionService_552_1_EffectTurnResistanceDecrease(nHitDice);
        }

        public NWEffect EffectTurnResistanceIncrease(Int32 nHitDice)
        {
            return ScriptHost.ExecuteActionService_553_1_EffectTurnResistanceIncrease(nHitDice);
        }

        public void PopUpDeathGUIPanel(UInt32 oPC, Int32 bRespawnButtonEnabled, Int32 bWaitForHelpButtonEnabled, Int32 nHelpStringReference, String sHelpString)
        {
            ScriptHost.ExecuteActionService_554_5_PopUpDeathGUIPanel(oPC, bRespawnButtonEnabled, bWaitForHelpButtonEnabled, nHelpStringReference, sHelpString);
        }

        public void SetTrapDisabled(UInt32 oTrap)
        {
            ScriptHost.ExecuteActionService_555_1_SetTrapDisabled(oTrap);
        }

        public UInt32 GetLastHostileActor(UInt32 oVictim)
        {
            return ScriptHost.ExecuteActionService_556_1_GetLastHostileActor(oVictim);
        }

        public void ExportAllCharacters()
        {
            ScriptHost.ExecuteActionService_557_0_ExportAllCharacters();
        }

        public Int32 MusicBackgroundGetDayTrack(UInt32 oArea)
        {
            return ScriptHost.ExecuteActionService_558_1_MusicBackgroundGetDayTrack(oArea);
        }

        public Int32 MusicBackgroundGetNightTrack(UInt32 oArea)
        {
            return ScriptHost.ExecuteActionService_559_1_MusicBackgroundGetNightTrack(oArea);
        }

        public void WriteTimestampedLogEntry(String sLogEntry)
        {
            ScriptHost.ExecuteActionService_560_1_WriteTimestampedLogEntry(sLogEntry);
        }

        public String GetModuleName()
        {
            return ScriptHost.ExecuteActionService_561_0_GetModuleName();
        }

        public UInt32 GetFactionLeader(UInt32 oMemberOfFaction)
        {
            return ScriptHost.ExecuteActionService_562_1_GetFactionLeader(oMemberOfFaction);
        }

        public void SendMessageToAllDMs(String szMessage)
        {
            ScriptHost.ExecuteActionService_563_1_SendMessageToAllDMs(szMessage);
        }

        public void EndGame(String sEndMovie)
        {
            ScriptHost.ExecuteActionService_564_1_EndGame(sEndMovie);
        }

        public void BootPC(UInt32 oPlayer)
        {
            ScriptHost.ExecuteActionService_565_1_BootPC(oPlayer);
        }

        public void ActionCounterSpell(UInt32 oCounterSpellTarget)
        {
            ScriptHost.ExecuteActionService_566_1_ActionCounterSpell(oCounterSpellTarget);
        }

        public void AmbientSoundSetDayVolume(UInt32 oArea, Int32 nVolume)
        {
            ScriptHost.ExecuteActionService_567_2_AmbientSoundSetDayVolume(oArea, nVolume);
        }

        public void AmbientSoundSetNightVolume(UInt32 oArea, Int32 nVolume)
        {
            ScriptHost.ExecuteActionService_568_2_AmbientSoundSetNightVolume(oArea, nVolume);
        }

        public Int32 MusicBackgroundGetBattleTrack(UInt32 oArea)
        {
            return ScriptHost.ExecuteActionService_569_1_MusicBackgroundGetBattleTrack(oArea);
        }

        public Int32 GetHasInventory(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_570_1_GetHasInventory(oObject);
        }

        public float GetStrRefSoundDuration(Int32 nStrRef)
        {
            return ScriptHost.ExecuteActionService_571_1_GetStrRefSoundDuration(nStrRef);
        }

        public void AddToParty(UInt32 oPC, UInt32 oPartyLeader)
        {
            ScriptHost.ExecuteActionService_572_2_AddToParty(oPC, oPartyLeader);
        }

        public void RemoveFromParty(UInt32 oPC)
        {
            ScriptHost.ExecuteActionService_573_1_RemoveFromParty(oPC);
        }

        public Int32 GetStealthMode(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_574_1_GetStealthMode(oCreature);
        }

        public Int32 GetDetectMode(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_575_1_GetDetectMode(oCreature);
        }

        public Int32 GetDefensiveCastingMode(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_576_1_GetDefensiveCastingMode(oCreature);
        }

        public Int32 GetAppearanceType(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_577_1_GetAppearanceType(oCreature);
        }

        public void SpawnScriptDebugger()
        {
            ScriptHost.ExecuteActionService_578_0_SpawnScriptDebugger();
        }

        public Int32 GetModuleItemAcquiredStackSize()
        {
            return ScriptHost.ExecuteActionService_579_0_GetModuleItemAcquiredStackSize();
        }

        public void DecrementRemainingFeatUses(UInt32 oCreature, Int32 nFeat)
        {
            ScriptHost.ExecuteActionService_580_2_DecrementRemainingFeatUses(oCreature, nFeat);
        }

        public void DecrementRemainingSpellUses(UInt32 oCreature, Int32 nSpell)
        {
            ScriptHost.ExecuteActionService_581_2_DecrementRemainingSpellUses(oCreature, nSpell);
        }

        public String GetResRef(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_582_1_GetResRef(oObject);
        }

        public NWEffect EffectPetrify()
        {
            return ScriptHost.ExecuteActionService_583_0_EffectPetrify();
        }

        public UInt32 CopyItem(UInt32 oItem, UInt32 oTargetInventory, Int32 bCopyVars)
        {
            return ScriptHost.ExecuteActionService_584_3_CopyItem(oItem, oTargetInventory, bCopyVars);
        }

        public NWEffect EffectCutsceneParalyze()
        {
            return ScriptHost.ExecuteActionService_585_0_EffectCutsceneParalyze();
        }

        public Int32 GetDroppableFlag(UInt32 oItem)
        {
            return ScriptHost.ExecuteActionService_586_1_GetDroppableFlag(oItem);
        }

        public Int32 GetUseableFlag(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_587_1_GetUseableFlag(oObject);
        }

        public Int32 GetStolenFlag(UInt32 oStolen)
        {
            return ScriptHost.ExecuteActionService_588_1_GetStolenFlag(oStolen);
        }

        public void SetCampaignFloat(String sCampaignName, String sVarName, float flFloat, UInt32 oPlayer)
        {
            ScriptHost.ExecuteActionService_589_4_SetCampaignFloat(sCampaignName, sVarName, (Single)flFloat, oPlayer);
        }

        public void SetCampaignInt(String sCampaignName, String sVarName, Int32 nInt, UInt32 oPlayer)
        {
            ScriptHost.ExecuteActionService_590_4_SetCampaignInt(sCampaignName, sVarName, nInt, oPlayer);
        }

        public void SetCampaignVector(String sCampaignName, String sVarName, NWScript.Vector3 vVector, UInt32 oPlayer)
        {
            ScriptHost.ExecuteActionService_591_6_SetCampaignVector(sCampaignName, sVarName, vVector.z, vVector.y, vVector.x, oPlayer);
        }

        public void SetCampaignLocation(String sCampaignName, String sVarName, NWLocation locLocation, UInt32 oPlayer)
        {
            ScriptHost.ExecuteActionService_592_4_SetCampaignLocation(sCampaignName, sVarName, locLocation, oPlayer);
        }

        public void SetCampaignString(String sCampaignName, String sVarName, String sString, UInt32 oPlayer)
        {
            ScriptHost.ExecuteActionService_593_4_SetCampaignString(sCampaignName, sVarName, sString, oPlayer);
        }

        public void DestroyCampaignDatabase(String sCampaignName)
        {
            ScriptHost.ExecuteActionService_594_1_DestroyCampaignDatabase(sCampaignName);
        }

        public float GetCampaignFloat(String sCampaignName, String sVarName, UInt32 oPlayer)
        {
            return ScriptHost.ExecuteActionService_595_3_GetCampaignFloat(sCampaignName, sVarName, oPlayer);
        }

        public Int32 GetCampaignInt(String sCampaignName, String sVarName, UInt32 oPlayer)
        {
            return ScriptHost.ExecuteActionService_596_3_GetCampaignInt(sCampaignName, sVarName, oPlayer);
        }

        public NWScript.Vector3 GetCampaignVector(String sCampaignName, String sVarName, UInt32 oPlayer)
        {
            return ScriptHost.ExecuteActionService_597_3_GetCampaignVector(sCampaignName, sVarName, oPlayer);
        }

        public NWLocation GetCampaignLocation(String sCampaignName, String sVarName, UInt32 oPlayer)
        {
            return ScriptHost.ExecuteActionService_598_3_GetCampaignLocation(sCampaignName, sVarName, oPlayer);
        }

        public String GetCampaignString(String sCampaignName, String sVarName, UInt32 oPlayer)
        {
            return ScriptHost.ExecuteActionService_599_3_GetCampaignString(sCampaignName, sVarName, oPlayer);
        }

        public UInt32 CopyObject(UInt32 oSource, NWLocation locLocation, UInt32 oOwner, String sNewTag)
        {
            return ScriptHost.ExecuteActionService_600_4_CopyObject(oSource, locLocation, oOwner, sNewTag);
        }

        public void DeleteCampaignVariable(String sCampaignName, String sVarName, UInt32 oPlayer)
        {
            ScriptHost.ExecuteActionService_601_3_DeleteCampaignVariable(sCampaignName, sVarName, oPlayer);
        }

        public Int32 StoreCampaignObject(String sCampaignName, String sVarName, UInt32 oObject, UInt32 oPlayer)
        {
            return ScriptHost.ExecuteActionService_602_4_StoreCampaignObject(sCampaignName, sVarName, oObject, oPlayer);
        }

        public UInt32 RetrieveCampaignObject(String sCampaignName, String sVarName, NWLocation locLocation, UInt32 oOwner, UInt32 oPlayer)
        {
            return ScriptHost.ExecuteActionService_603_5_RetrieveCampaignObject(sCampaignName, sVarName, locLocation, oOwner, oPlayer);
        }

        public NWEffect EffectCutsceneDominated()
        {
            return ScriptHost.ExecuteActionService_604_0_EffectCutsceneDominated();
        }

        public Int32 GetItemStackSize(UInt32 oItem)
        {
            return ScriptHost.ExecuteActionService_605_1_GetItemStackSize(oItem);
        }

        public void SetItemStackSize(UInt32 oItem, Int32 nSize, Int32 bDisplayFeedback)
        {
            ScriptHost.ExecuteActionService_606_3_SetItemStackSize(oItem, nSize, bDisplayFeedback);
        }

        public Int32 GetItemCharges(UInt32 oItem)
        {
            return ScriptHost.ExecuteActionService_607_1_GetItemCharges(oItem);
        }

        public void SetItemCharges(UInt32 oItem, Int32 nCharges)
        {
            ScriptHost.ExecuteActionService_608_2_SetItemCharges(oItem, nCharges);
        }

        public void AddItemProperty(Int32 nDurationType, NWItemProperty ipProperty, UInt32 oItem, float fDuration)
        {
            ScriptHost.ExecuteActionService_609_4_AddItemProperty(nDurationType, ipProperty, oItem, (Single)fDuration);
        }

        public void RemoveItemProperty(UInt32 oItem, NWItemProperty ipProperty)
        {
            ScriptHost.ExecuteActionService_610_2_RemoveItemProperty(oItem, ipProperty);
        }

        public Int32 GetIsItemPropertyValid(NWItemProperty ipProperty)
        {
            return ScriptHost.ExecuteActionService_611_1_GetIsItemPropertyValid(ipProperty);
        }

        public NWItemProperty GetFirstItemProperty(UInt32 oItem)
        {
            return ScriptHost.ExecuteActionService_612_1_GetFirstItemProperty(oItem);
        }

        public NWItemProperty GetNextItemProperty(UInt32 oItem)
        {
            return ScriptHost.ExecuteActionService_613_1_GetNextItemProperty(oItem);
        }

        public Int32 GetItemPropertyType(NWItemProperty ip)
        {
            return ScriptHost.ExecuteActionService_614_1_GetItemPropertyType(ip);
        }

        public Int32 GetItemPropertyDurationType(NWItemProperty ip)
        {
            return ScriptHost.ExecuteActionService_615_1_GetItemPropertyDurationType(ip);
        }

        public NWItemProperty ItemPropertyAbilityBonus(Int32 nAbility, Int32 nBonus)
        {
            return ScriptHost.ExecuteActionService_616_2_ItemPropertyAbilityBonus(nAbility, nBonus);
        }

        public NWItemProperty ItemPropertyACBonus(Int32 nBonus)
        {
            return ScriptHost.ExecuteActionService_617_1_ItemPropertyACBonus(nBonus);
        }

        public NWItemProperty ItemPropertyACBonusVsAlign(Int32 nAlignGroup, Int32 nACBonus)
        {
            return ScriptHost.ExecuteActionService_618_2_ItemPropertyACBonusVsAlign(nAlignGroup, nACBonus);
        }

        public NWItemProperty ItemPropertyACBonusVsDmgType(Int32 nDamageType, Int32 nACBonus)
        {
            return ScriptHost.ExecuteActionService_619_2_ItemPropertyACBonusVsDmgType(nDamageType, nACBonus);
        }

        public NWItemProperty ItemPropertyACBonusVsRace(Int32 nRace, Int32 nACBonus)
        {
            return ScriptHost.ExecuteActionService_620_2_ItemPropertyACBonusVsRace(nRace, nACBonus);
        }

        public NWItemProperty ItemPropertyACBonusVsSAlign(Int32 nAlign, Int32 nACBonus)
        {
            return ScriptHost.ExecuteActionService_621_2_ItemPropertyACBonusVsSAlign(nAlign, nACBonus);
        }

        public NWItemProperty ItemPropertyEnhancementBonus(Int32 nEnhancementBonus)
        {
            return ScriptHost.ExecuteActionService_622_1_ItemPropertyEnhancementBonus(nEnhancementBonus);
        }

        public NWItemProperty ItemPropertyEnhancementBonusVsAlign(Int32 nAlignGroup, Int32 nBonus)
        {
            return ScriptHost.ExecuteActionService_623_2_ItemPropertyEnhancementBonusVsAlign(nAlignGroup, nBonus);
        }

        public NWItemProperty ItemPropertyEnhancementBonusVsRace(Int32 nRace, Int32 nBonus)
        {
            return ScriptHost.ExecuteActionService_624_2_ItemPropertyEnhancementBonusVsRace(nRace, nBonus);
        }

        public NWItemProperty ItemPropertyEnhancementBonusVsSAlign(Int32 nAlign, Int32 nBonus)
        {
            return ScriptHost.ExecuteActionService_625_2_ItemPropertyEnhancementBonusVsSAlign(nAlign, nBonus);
        }

        public NWItemProperty ItemPropertyEnhancementPenalty(Int32 nPenalty)
        {
            return ScriptHost.ExecuteActionService_626_1_ItemPropertyEnhancementPenalty(nPenalty);
        }

        public NWItemProperty ItemPropertyWeightReduction(Int32 nReduction)
        {
            return ScriptHost.ExecuteActionService_627_1_ItemPropertyWeightReduction(nReduction);
        }

        public NWItemProperty ItemPropertyBonusFeat(Int32 nFeat)
        {
            return ScriptHost.ExecuteActionService_628_1_ItemPropertyBonusFeat(nFeat);
        }

        public NWItemProperty ItemPropertyBonusLevelSpell(Int32 nClass, Int32 nSpellLevel)
        {
            return ScriptHost.ExecuteActionService_629_2_ItemPropertyBonusLevelSpell(nClass, nSpellLevel);
        }

        public NWItemProperty ItemPropertyCastSpell(Int32 nSpell, Int32 nNumUses)
        {
            return ScriptHost.ExecuteActionService_630_2_ItemPropertyCastSpell(nSpell, nNumUses);
        }

        public NWItemProperty ItemPropertyDamageBonus(Int32 nDamageType, Int32 nDamage)
        {
            return ScriptHost.ExecuteActionService_631_2_ItemPropertyDamageBonus(nDamageType, nDamage);
        }

        public NWItemProperty ItemPropertyDamageBonusVsAlign(Int32 nAlignGroup, Int32 nDamageType, Int32 nDamage)
        {
            return ScriptHost.ExecuteActionService_632_3_ItemPropertyDamageBonusVsAlign(nAlignGroup, nDamageType, nDamage);
        }

        public NWItemProperty ItemPropertyDamageBonusVsRace(Int32 nRace, Int32 nDamageType, Int32 nDamage)
        {
            return ScriptHost.ExecuteActionService_633_3_ItemPropertyDamageBonusVsRace(nRace, nDamageType, nDamage);
        }

        public NWItemProperty ItemPropertyDamageBonusVsSAlign(Int32 nAlign, Int32 nDamageType, Int32 nDamage)
        {
            return ScriptHost.ExecuteActionService_634_3_ItemPropertyDamageBonusVsSAlign(nAlign, nDamageType, nDamage);
        }

        public NWItemProperty ItemPropertyDamageImmunity(Int32 nDamageType, Int32 nImmuneBonus)
        {
            return ScriptHost.ExecuteActionService_635_2_ItemPropertyDamageImmunity(nDamageType, nImmuneBonus);
        }

        public NWItemProperty ItemPropertyDamagePenalty(Int32 nPenalty)
        {
            return ScriptHost.ExecuteActionService_636_1_ItemPropertyDamagePenalty(nPenalty);
        }

        public NWItemProperty ItemPropertyDamageReduction(Int32 nAmount, Int32 nDRSubType, Int32 nLimit, Int32 nDRType)
        {
            return ScriptHost.ExecuteActionService_637_4_ItemPropertyDamageReduction(nAmount, nDRSubType, nLimit, nDRType);
        }

        public NWItemProperty ItemPropertyDamageResistance(Int32 nDamageType, Int32 nHPResist)
        {
            return ScriptHost.ExecuteActionService_638_2_ItemPropertyDamageResistance(nDamageType, nHPResist);
        }

        public NWItemProperty ItemPropertyDamageVulnerability(Int32 nDamageType, Int32 nVulnerability)
        {
            return ScriptHost.ExecuteActionService_639_2_ItemPropertyDamageVulnerability(nDamageType, nVulnerability);
        }

        public NWItemProperty ItemPropertyDarkvision()
        {
            return ScriptHost.ExecuteActionService_640_0_ItemPropertyDarkvision();
        }

        public NWItemProperty ItemPropertyDecreaseAbility(Int32 nAbility, Int32 nModifier)
        {
            return ScriptHost.ExecuteActionService_641_2_ItemPropertyDecreaseAbility(nAbility, nModifier);
        }

        public NWItemProperty ItemPropertyDecreaseAC(Int32 nModifierType, Int32 nPenalty)
        {
            return ScriptHost.ExecuteActionService_642_2_ItemPropertyDecreaseAC(nModifierType, nPenalty);
        }

        public NWItemProperty ItemPropertyDecreaseSkill(Int32 nSkill, Int32 nPenalty)
        {
            return ScriptHost.ExecuteActionService_643_2_ItemPropertyDecreaseSkill(nSkill, nPenalty);
        }

        public NWItemProperty ItemPropertyContainerReducedWeight(Int32 nContainerType)
        {
            return ScriptHost.ExecuteActionService_644_1_ItemPropertyContainerReducedWeight(nContainerType);
        }

        public NWItemProperty ItemPropertyExtraMeleeDamageType(Int32 nDamageType)
        {
            return ScriptHost.ExecuteActionService_645_1_ItemPropertyExtraMeleeDamageType(nDamageType);
        }

        public NWItemProperty ItemPropertyExtraRangeDamageType(Int32 nDamageType)
        {
            return ScriptHost.ExecuteActionService_646_1_ItemPropertyExtraRangeDamageType(nDamageType);
        }

        public NWItemProperty ItemPropertyHaste()
        {
            return ScriptHost.ExecuteActionService_647_0_ItemPropertyHaste();
        }

        public NWItemProperty ItemPropertyHolyAvenger()
        {
            return ScriptHost.ExecuteActionService_648_0_ItemPropertyHolyAvenger();
        }

        public NWItemProperty ItemPropertyImmunityMisc(Int32 nImmunityType)
        {
            return ScriptHost.ExecuteActionService_649_1_ItemPropertyImmunityMisc(nImmunityType);
        }

        public NWItemProperty ItemPropertyImprovedEvasion()
        {
            return ScriptHost.ExecuteActionService_650_0_ItemPropertyImprovedEvasion();
        }

        public NWItemProperty ItemPropertyBonusSpellResistance(Int32 nBonus)
        {
            return ScriptHost.ExecuteActionService_651_1_ItemPropertyBonusSpellResistance(nBonus);
        }

        public NWItemProperty ItemPropertyBonusSavingThrowVsX(Int32 nBonusType, Int32 nBonus)
        {
            return ScriptHost.ExecuteActionService_652_2_ItemPropertyBonusSavingThrowVsX(nBonusType, nBonus);
        }

        public NWItemProperty ItemPropertyBonusSavingThrow(Int32 nBaseSaveType, Int32 nBonus)
        {
            return ScriptHost.ExecuteActionService_653_2_ItemPropertyBonusSavingThrow(nBaseSaveType, nBonus);
        }

        public NWItemProperty ItemPropertyKeen()
        {
            return ScriptHost.ExecuteActionService_654_0_ItemPropertyKeen();
        }

        public NWItemProperty ItemPropertyLight(Int32 nBrightness, Int32 nColor)
        {
            return ScriptHost.ExecuteActionService_655_2_ItemPropertyLight(nBrightness, nColor);
        }

        public NWItemProperty ItemPropertyMaxRangeStrengthMod(Int32 nModifier)
        {
            return ScriptHost.ExecuteActionService_656_1_ItemPropertyMaxRangeStrengthMod(nModifier);
        }

        public NWItemProperty ItemPropertyNoDamage()
        {
            return ScriptHost.ExecuteActionService_657_0_ItemPropertyNoDamage();
        }

        public NWItemProperty ItemPropertyOnHitProps(Int32 nProperty, Int32 nSaveDC, Int32 nSpecial)
        {
            return ScriptHost.ExecuteActionService_658_3_ItemPropertyOnHitProps(nProperty, nSaveDC, nSpecial);
        }

        public NWItemProperty ItemPropertyReducedSavingThrowVsX(Int32 nBaseSaveType, Int32 nPenalty)
        {
            return ScriptHost.ExecuteActionService_659_2_ItemPropertyReducedSavingThrowVsX(nBaseSaveType, nPenalty);
        }

        public NWItemProperty ItemPropertyReducedSavingThrow(Int32 nBonusType, Int32 nPenalty)
        {
            return ScriptHost.ExecuteActionService_660_2_ItemPropertyReducedSavingThrow(nBonusType, nPenalty);
        }

        public NWItemProperty ItemPropertyRegeneration(Int32 nRegenAmount)
        {
            return ScriptHost.ExecuteActionService_661_1_ItemPropertyRegeneration(nRegenAmount);
        }

        public NWItemProperty ItemPropertySkillBonus(Int32 nSkill, Int32 nBonus)
        {
            return ScriptHost.ExecuteActionService_662_2_ItemPropertySkillBonus(nSkill, nBonus);
        }

        public NWItemProperty ItemPropertySpellImmunitySpecific(Int32 nSpell)
        {
            return ScriptHost.ExecuteActionService_663_1_ItemPropertySpellImmunitySpecific(nSpell);
        }

        public NWItemProperty ItemPropertySpellImmunitySchool(Int32 nSchool)
        {
            return ScriptHost.ExecuteActionService_664_1_ItemPropertySpellImmunitySchool(nSchool);
        }

        public NWItemProperty ItemPropertyThievesTools(Int32 nModifier)
        {
            return ScriptHost.ExecuteActionService_665_1_ItemPropertyThievesTools(nModifier);
        }

        public NWItemProperty ItemPropertyAttackBonus(Int32 nBonus)
        {
            return ScriptHost.ExecuteActionService_666_1_ItemPropertyAttackBonus(nBonus);
        }

        public NWItemProperty ItemPropertyAttackBonusVsAlign(Int32 nAlignGroup, Int32 nBonus)
        {
            return ScriptHost.ExecuteActionService_667_2_ItemPropertyAttackBonusVsAlign(nAlignGroup, nBonus);
        }

        public NWItemProperty ItemPropertyAttackBonusVsRace(Int32 nRace, Int32 nBonus)
        {
            return ScriptHost.ExecuteActionService_668_2_ItemPropertyAttackBonusVsRace(nRace, nBonus);
        }

        public NWItemProperty ItemPropertyAttackBonusVsSAlign(Int32 nAlignment, Int32 nBonus)
        {
            return ScriptHost.ExecuteActionService_669_2_ItemPropertyAttackBonusVsSAlign(nAlignment, nBonus);
        }

        public NWItemProperty ItemPropertyAttackPenalty(Int32 nPenalty)
        {
            return ScriptHost.ExecuteActionService_670_1_ItemPropertyAttackPenalty(nPenalty);
        }

        public NWItemProperty ItemPropertyUnlimitedAmmo(Int32 nAmmoDamage)
        {
            return ScriptHost.ExecuteActionService_671_1_ItemPropertyUnlimitedAmmo(nAmmoDamage);
        }

        public NWItemProperty ItemPropertyLimitUseByAlign(Int32 nAlignGroup)
        {
            return ScriptHost.ExecuteActionService_672_1_ItemPropertyLimitUseByAlign(nAlignGroup);
        }

        public NWItemProperty ItemPropertyLimitUseByClass(Int32 nClass)
        {
            return ScriptHost.ExecuteActionService_673_1_ItemPropertyLimitUseByClass(nClass);
        }

        public NWItemProperty ItemPropertyLimitUseByRace(Int32 nRace)
        {
            return ScriptHost.ExecuteActionService_674_1_ItemPropertyLimitUseByRace(nRace);
        }

        public NWItemProperty ItemPropertyLimitUseBySAlign(Int32 nAlignment)
        {
            return ScriptHost.ExecuteActionService_675_1_ItemPropertyLimitUseBySAlign(nAlignment);
        }

        public NWItemProperty ItemPropertyBonusHitpoints(Int32 nBonusType)
        {
            return ScriptHost.ExecuteActionService_676_1_ItemPropertyBonusHitpoints(nBonusType);
        }

        public NWItemProperty ItemPropertyVampiricRegeneration(Int32 nRegenAmount)
        {
            return ScriptHost.ExecuteActionService_677_1_ItemPropertyVampiricRegeneration(nRegenAmount);
        }

        public NWItemProperty ItemPropertyTrap(Int32 nTrapLevel, Int32 nTrapType)
        {
            return ScriptHost.ExecuteActionService_678_2_ItemPropertyTrap(nTrapLevel, nTrapType);
        }

        public NWItemProperty ItemPropertyTrueSeeing()
        {
            return ScriptHost.ExecuteActionService_679_0_ItemPropertyTrueSeeing();
        }

        public NWItemProperty ItemPropertyOnMonsterHitProperties(Int32 nProperty, Int32 nSpecial)
        {
            return ScriptHost.ExecuteActionService_680_2_ItemPropertyOnMonsterHitProperties(nProperty, nSpecial);
        }

        public NWItemProperty ItemPropertyTurnResistance(Int32 nModifier)
        {
            return ScriptHost.ExecuteActionService_681_1_ItemPropertyTurnResistance(nModifier);
        }

        public NWItemProperty ItemPropertyMassiveCritical(Int32 nDamage)
        {
            return ScriptHost.ExecuteActionService_682_1_ItemPropertyMassiveCritical(nDamage);
        }

        public NWItemProperty ItemPropertyFreeAction()
        {
            return ScriptHost.ExecuteActionService_683_0_ItemPropertyFreeAction();
        }

        public NWItemProperty ItemPropertyMonsterDamage(Int32 nDamage)
        {
            return ScriptHost.ExecuteActionService_684_1_ItemPropertyMonsterDamage(nDamage);
        }

        public NWItemProperty ItemPropertyImmunityToSpellLevel(Int32 nLevel)
        {
            return ScriptHost.ExecuteActionService_685_1_ItemPropertyImmunityToSpellLevel(nLevel);
        }

        public NWItemProperty ItemPropertySpecialWalk(Int32 nWalkType)
        {
            return ScriptHost.ExecuteActionService_686_1_ItemPropertySpecialWalk(nWalkType);
        }

        public NWItemProperty ItemPropertyHealersKit(Int32 nModifier)
        {
            return ScriptHost.ExecuteActionService_687_1_ItemPropertyHealersKit(nModifier);
        }

        public NWItemProperty ItemPropertyWeightIncrease(Int32 nWeight)
        {
            return ScriptHost.ExecuteActionService_688_1_ItemPropertyWeightIncrease(nWeight);
        }

        public Int32 GetIsSkillSuccessful(UInt32 oTarget, Int32 nSkill, Int32 nDifficulty, Int32 bDisplayFeedback)
        {
            return ScriptHost.ExecuteActionService_689_4_GetIsSkillSuccessful(oTarget, nSkill, nDifficulty, bDisplayFeedback);
        }

        public NWEffect EffectSpellFailure(Int32 nPercent, Int32 nSpellSchool)
        {
            return ScriptHost.ExecuteActionService_690_2_EffectSpellFailure(nPercent, nSpellSchool);
        }

        public void SpeakStringByStrRef(Int32 nStrRef, Int32 nTalkVolume)
        {
            ScriptHost.ExecuteActionService_691_2_SpeakStringByStrRef(nStrRef, nTalkVolume);
        }

        public void SetCutsceneMode(UInt32 oCreature, Int32 nInCutscene)
        {
            ScriptHost.ExecuteActionService_692_2_SetCutsceneMode(oCreature, nInCutscene);
        }

        public UInt32 GetLastPCToCancelCutscene()
        {
            return ScriptHost.ExecuteActionService_693_0_GetLastPCToCancelCutscene();
        }

        public float GetDialogSoundLength(Int32 nStrRef)
        {
            return ScriptHost.ExecuteActionService_694_1_GetDialogSoundLength(nStrRef);
        }

        public void FadeFromBlack(UInt32 oCreature, float fSpeed)
        {
            ScriptHost.ExecuteActionService_695_2_FadeFromBlack(oCreature, (Single)fSpeed);
        }

        public void FadeToBlack(UInt32 oCreature, float fSpeed, float fFailsafe, Int32 nColor)
        {
            ScriptHost.ExecuteActionService_696_4_FadeToBlack(oCreature, (Single)fSpeed, (Single)fFailsafe, nColor);
        }

        public void StopFade(UInt32 oCreature)
        {
            ScriptHost.ExecuteActionService_697_1_StopFade(oCreature);
        }

        public void BlackScreen(UInt32 oCreature, Int32 nColor)
        {
            ScriptHost.ExecuteActionService_698_2_BlackScreen(oCreature, nColor);
        }

        public Int32 GetBaseAttackBonus(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_699_1_GetBaseAttackBonus(oCreature);
        }

        public void SetImmortal(UInt32 oCreature, Int32 bImmortal)
        {
            ScriptHost.ExecuteActionService_700_2_SetImmortal(oCreature, bImmortal);
        }

        public void OpenInventory(UInt32 oCreature, UInt32 oPlayer)
        {
            ScriptHost.ExecuteActionService_701_2_OpenInventory(oCreature, oPlayer);
        }

        public void StoreCameraFacing()
        {
            ScriptHost.ExecuteActionService_702_0_StoreCameraFacing();
        }

        public void RestoreCameraFacing()
        {
            ScriptHost.ExecuteActionService_703_0_RestoreCameraFacing();
        }

        public Int32 LevelUpHenchman(UInt32 oCreature, Int32 nClass, Int32 bReadyAllSpells, Int32 nPackage)
        {
            return ScriptHost.ExecuteActionService_704_4_LevelUpHenchman(oCreature, nClass, bReadyAllSpells, nPackage);
        }

        public void SetDroppableFlag(UInt32 oItem, Int32 bDroppable)
        {
            ScriptHost.ExecuteActionService_705_2_SetDroppableFlag(oItem, bDroppable);
        }

        public Int32 GetWeight(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_706_1_GetWeight(oTarget);
        }

        public UInt32 GetModuleItemAcquiredBy()
        {
            return ScriptHost.ExecuteActionService_707_0_GetModuleItemAcquiredBy();
        }

        public Int32 GetImmortal(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_708_1_GetImmortal(oTarget);
        }

        public void DoWhirlwindAttack(Int32 bDisplayFeedback, Int32 bImproved)
        {
            ScriptHost.ExecuteActionService_709_2_DoWhirlwindAttack(bDisplayFeedback, bImproved);
        }

        public String Get2DAString(String s2DA, String sColumn, Int32 nRow)
        {
            return ScriptHost.ExecuteActionService_710_3_Get2DAString(s2DA, sColumn, nRow);
        }

        public NWEffect EffectEthereal()
        {
            return ScriptHost.ExecuteActionService_711_0_EffectEthereal();
        }

        public Int32 GetAILevel(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_712_1_GetAILevel(oTarget);
        }

        public void SetAILevel(UInt32 oTarget, Int32 nAILevel)
        {
            ScriptHost.ExecuteActionService_713_2_SetAILevel(oTarget, nAILevel);
        }

        public Int32 GetIsPossessedFamiliar(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_714_1_GetIsPossessedFamiliar(oCreature);
        }

        public void UnpossessFamiliar(UInt32 oCreature)
        {
            ScriptHost.ExecuteActionService_715_1_UnpossessFamiliar(oCreature);
        }

        public Int32 GetIsAreaInterior(UInt32 oArea)
        {
            return ScriptHost.ExecuteActionService_716_1_GetIsAreaInterior(oArea);
        }

        public void SendMessageToPCByStrRef(UInt32 oPlayer, Int32 nStrRef)
        {
            ScriptHost.ExecuteActionService_717_2_SendMessageToPCByStrRef(oPlayer, nStrRef);
        }

        public void IncrementRemainingFeatUses(UInt32 oCreature, Int32 nFeat)
        {
            ScriptHost.ExecuteActionService_718_2_IncrementRemainingFeatUses(oCreature, nFeat);
        }

        public void ExportSingleCharacter(UInt32 oPlayer)
        {
            ScriptHost.ExecuteActionService_719_1_ExportSingleCharacter(oPlayer);
        }

        public void PlaySoundByStrRef(Int32 nStrRef, Int32 nRunAsAction)
        {
            ScriptHost.ExecuteActionService_720_2_PlaySoundByStrRef(nStrRef, nRunAsAction);
        }

        public void SetSubRace(UInt32 oCreature, String sSubRace)
        {
            ScriptHost.ExecuteActionService_721_2_SetSubRace(oCreature, sSubRace);
        }

        public void SetDeity(UInt32 oCreature, String sDeity)
        {
            ScriptHost.ExecuteActionService_722_2_SetDeity(oCreature, sDeity);
        }

        public Int32 GetIsDMPossessed(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_723_1_GetIsDMPossessed(oCreature);
        }

        public Int32 GetWeather(UInt32 oArea, Int32 nWeatherType)
        {
            return ScriptHost.ExecuteActionService_724_2_GetWeather(oArea, nWeatherType);
        }

        public Int32 GetIsAreaNatural(UInt32 oArea)
        {
            return ScriptHost.ExecuteActionService_725_1_GetIsAreaNatural(oArea);
        }

        public Int32 GetIsAreaAboveGround(UInt32 oArea)
        {
            return ScriptHost.ExecuteActionService_726_1_GetIsAreaAboveGround(oArea);
        }

        public UInt32 GetPCItemLastEquipped()
        {
            return ScriptHost.ExecuteActionService_727_0_GetPCItemLastEquipped();
        }

        public UInt32 GetPCItemLastEquippedBy()
        {
            return ScriptHost.ExecuteActionService_728_0_GetPCItemLastEquippedBy();
        }

        public UInt32 GetPCItemLastUnequipped()
        {
            return ScriptHost.ExecuteActionService_729_0_GetPCItemLastUnequipped();
        }

        public UInt32 GetPCItemLastUnequippedBy()
        {
            return ScriptHost.ExecuteActionService_730_0_GetPCItemLastUnequippedBy();
        }

        public UInt32 CopyItemAndModify(UInt32 oItem, Int32 nType, Int32 nIndex, Int32 nNewValue, Int32 bCopyVars)
        {
            return ScriptHost.ExecuteActionService_731_5_CopyItemAndModify(oItem, nType, nIndex, nNewValue, bCopyVars);
        }

        public Int32 GetItemAppearance(UInt32 oItem, Int32 nType, Int32 nIndex)
        {
            return ScriptHost.ExecuteActionService_732_3_GetItemAppearance(oItem, nType, nIndex);
        }

        public NWItemProperty ItemPropertyOnHitCastSpell(Int32 nSpell, Int32 nLevel)
        {
            return ScriptHost.ExecuteActionService_733_2_ItemPropertyOnHitCastSpell(nSpell, nLevel);
        }

        public Int32 GetItemPropertySubType(NWItemProperty iProperty)
        {
            return ScriptHost.ExecuteActionService_734_1_GetItemPropertySubType(iProperty);
        }

        public Int32 GetActionMode(UInt32 oCreature, Int32 nMode)
        {
            return ScriptHost.ExecuteActionService_735_2_GetActionMode(oCreature, nMode);
        }

        public void SetActionMode(UInt32 oCreature, Int32 nMode, Int32 nStatus)
        {
            ScriptHost.ExecuteActionService_736_3_SetActionMode(oCreature, nMode, nStatus);
        }

        public Int32 GetArcaneSpellFailure(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_737_1_GetArcaneSpellFailure(oCreature);
        }

        public void ActionExamine(UInt32 oExamine)
        {
            ScriptHost.ExecuteActionService_738_1_ActionExamine(oExamine);
        }

        public NWItemProperty ItemPropertyVisualEffect(Int32 nEffect)
        {
            return ScriptHost.ExecuteActionService_739_1_ItemPropertyVisualEffect(nEffect);
        }

        public void SetLootable(UInt32 oCreature, Int32 bLootable)
        {
            ScriptHost.ExecuteActionService_740_2_SetLootable(oCreature, bLootable);
        }

        public Int32 GetLootable(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_741_1_GetLootable(oCreature);
        }

        public float GetCutsceneCameraMoveRate(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_742_1_GetCutsceneCameraMoveRate(oCreature);
        }

        public void SetCutsceneCameraMoveRate(UInt32 oCreature, float fRate)
        {
            ScriptHost.ExecuteActionService_743_2_SetCutsceneCameraMoveRate(oCreature, (Single)fRate);
        }

        public Int32 GetItemCursedFlag(UInt32 oItem)
        {
            return ScriptHost.ExecuteActionService_744_1_GetItemCursedFlag(oItem);
        }

        public void SetItemCursedFlag(UInt32 oItem, Int32 nCursed)
        {
            ScriptHost.ExecuteActionService_745_2_SetItemCursedFlag(oItem, nCursed);
        }

        public void SetMaxHenchmen(Int32 nNumHenchmen)
        {
            ScriptHost.ExecuteActionService_746_1_SetMaxHenchmen(nNumHenchmen);
        }

        public Int32 GetMaxHenchmen()
        {
            return ScriptHost.ExecuteActionService_747_0_GetMaxHenchmen();
        }

        public Int32 GetAssociateType(UInt32 oAssociate)
        {
            return ScriptHost.ExecuteActionService_748_1_GetAssociateType(oAssociate);
        }

        public Int32 GetSpellResistance(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_749_1_GetSpellResistance(oCreature);
        }

        public void DayToNight(UInt32 oPlayer, float fTransitionTime)
        {
            ScriptHost.ExecuteActionService_750_2_DayToNight(oPlayer, (Single)fTransitionTime);
        }

        public void NightToDay(UInt32 oPlayer, float fTransitionTime)
        {
            ScriptHost.ExecuteActionService_751_2_NightToDay(oPlayer, (Single)fTransitionTime);
        }

        public Int32 LineOfSightObject(UInt32 oSource, UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_752_2_LineOfSightObject(oSource, oTarget);
        }

        public Int32 LineOfSightVector(NWScript.Vector3 vSource, NWScript.Vector3 vTarget)
        {
            return ScriptHost.ExecuteActionService_753_6_LineOfSightVector(vSource.z, vSource.y, vSource.x, vTarget.z, vTarget.y, vTarget.x);
        }

        public Int32 GetLastSpellCastClass()
        {
            return ScriptHost.ExecuteActionService_754_0_GetLastSpellCastClass();
        }

        public void SetBaseAttackBonus(Int32 nBaseAttackBonus, UInt32 oCreature)
        {
            ScriptHost.ExecuteActionService_755_2_SetBaseAttackBonus(nBaseAttackBonus, oCreature);
        }

        public void RestoreBaseAttackBonus(UInt32 oCreature)
        {
            ScriptHost.ExecuteActionService_756_1_RestoreBaseAttackBonus(oCreature);
        }

        public NWEffect EffectCutsceneGhost()
        {
            return ScriptHost.ExecuteActionService_757_0_EffectCutsceneGhost();
        }

        public NWItemProperty ItemPropertyArcaneSpellFailure(Int32 nModLevel)
        {
            return ScriptHost.ExecuteActionService_758_1_ItemPropertyArcaneSpellFailure(nModLevel);
        }

        public Int32 GetStoreGold(UInt32 oidStore)
        {
            return ScriptHost.ExecuteActionService_759_1_GetStoreGold(oidStore);
        }

        public void SetStoreGold(UInt32 oidStore, Int32 nGold)
        {
            ScriptHost.ExecuteActionService_760_2_SetStoreGold(oidStore, nGold);
        }

        public Int32 GetStoreMaxBuyPrice(UInt32 oidStore)
        {
            return ScriptHost.ExecuteActionService_761_1_GetStoreMaxBuyPrice(oidStore);
        }

        public void SetStoreMaxBuyPrice(UInt32 oidStore, Int32 nMaxBuy)
        {
            ScriptHost.ExecuteActionService_762_2_SetStoreMaxBuyPrice(oidStore, nMaxBuy);
        }

        public Int32 GetStoreIdentifyCost(UInt32 oidStore)
        {
            return ScriptHost.ExecuteActionService_763_1_GetStoreIdentifyCost(oidStore);
        }

        public void SetStoreIdentifyCost(UInt32 oidStore, Int32 nCost)
        {
            ScriptHost.ExecuteActionService_764_2_SetStoreIdentifyCost(oidStore, nCost);
        }

        public void SetCreatureAppearanceType(UInt32 oCreature, Int32 nAppearanceType)
        {
            ScriptHost.ExecuteActionService_765_2_SetCreatureAppearanceType(oCreature, nAppearanceType);
        }

        public Int32 GetCreatureStartingPackage(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_766_1_GetCreatureStartingPackage(oCreature);
        }

        public NWEffect EffectCutsceneImmobilize()
        {
            return ScriptHost.ExecuteActionService_767_0_EffectCutsceneImmobilize();
        }

        public Int32 GetIsInSubArea(UInt32 oCreature, UInt32 oSubArea)
        {
            return ScriptHost.ExecuteActionService_768_2_GetIsInSubArea(oCreature, oSubArea);
        }

        public Int32 GetItemPropertyCostTable(NWItemProperty iProp)
        {
            return ScriptHost.ExecuteActionService_769_1_GetItemPropertyCostTable(iProp);
        }

        public Int32 GetItemPropertyCostTableValue(NWItemProperty iProp)
        {
            return ScriptHost.ExecuteActionService_770_1_GetItemPropertyCostTableValue(iProp);
        }

        public Int32 GetItemPropertyParam1(NWItemProperty iProp)
        {
            return ScriptHost.ExecuteActionService_771_1_GetItemPropertyParam1(iProp);
        }

        public Int32 GetItemPropertyParam1Value(NWItemProperty iProp)
        {
            return ScriptHost.ExecuteActionService_772_1_GetItemPropertyParam1Value(iProp);
        }

        public Int32 GetIsCreatureDisarmable(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_773_1_GetIsCreatureDisarmable(oCreature);
        }

        public void SetStolenFlag(UInt32 oItem, Int32 nStolenFlag)
        {
            ScriptHost.ExecuteActionService_774_2_SetStolenFlag(oItem, nStolenFlag);
        }

        public void ForceRest(UInt32 oCreature)
        {
            ScriptHost.ExecuteActionService_775_1_ForceRest(oCreature);
        }

        public void SetCameraHeight(UInt32 oPlayer, float fHeight)
        {
            ScriptHost.ExecuteActionService_776_2_SetCameraHeight(oPlayer, (Single)fHeight);
        }

        public Int32 SetGlobalInt(String sName, Int32 nValue)
        {
            return ScriptHost.ExecuteActionService_777_2_SetGlobalInt(sName, nValue);
        }

        public Int32 SetGlobalBool(String sName, Int32 bValue)
        {
            return ScriptHost.ExecuteActionService_778_2_SetGlobalBool(sName, bValue);
        }

        public Int32 SetGlobalString(String sName, String sValue)
        {
            return ScriptHost.ExecuteActionService_779_2_SetGlobalString(sName, sValue);
        }

        public Int32 SetGlobalFloat(String sName, float fValue)
        {
            return ScriptHost.ExecuteActionService_780_2_SetGlobalFloat(sName, (Single)fValue);
        }

        public Int32 GetGlobalInt(String sName)
        {
            return ScriptHost.ExecuteActionService_781_1_GetGlobalInt(sName);
        }

        public Int32 GetGlobalBool(String sName)
        {
            return ScriptHost.ExecuteActionService_782_1_GetGlobalBool(sName);
        }

        public String GetGlobalString(String sName)
        {
            return ScriptHost.ExecuteActionService_783_1_GetGlobalString(sName);
        }

        public float GetGlobalFloat(String sName)
        {
            return ScriptHost.ExecuteActionService_784_1_GetGlobalFloat(sName);
        }

        public Int32 SaveGlobalVariables(String sSaveName)
        {
            return ScriptHost.ExecuteActionService_785_1_SaveGlobalVariables(sSaveName);
        }

        public Int32 LoadGlobalVariables(String sLoadName)
        {
            return ScriptHost.ExecuteActionService_786_1_LoadGlobalVariables(sLoadName);
        }

        public void MountObject(UInt32 oMountingObject, UInt32 oObjectToMount)
        {
            ScriptHost.ExecuteActionService_787_2_MountObject(oMountingObject, oObjectToMount);
        }

        public void DismountObject(UInt32 oDismountingObject, UInt32 oObjectToDismount)
        {
            ScriptHost.ExecuteActionService_788_2_DismountObject(oDismountingObject, oObjectToDismount);
        }

        public Int32 GetJournalEntry(String szPlotID, UInt32 oObjectJournal)
        {
            return ScriptHost.ExecuteActionService_789_2_GetJournalEntry(szPlotID, oObjectJournal);
        }

        public NWEffect EffectNWN2ParticleEffect()
        {
            return ScriptHost.ExecuteActionService_790_0_EffectNWN2ParticleEffect();
        }

        public NWEffect EffectNWN2ParticleEffectFile(String sDefinitionFile)
        {
            return ScriptHost.ExecuteActionService_791_1_EffectNWN2ParticleEffectFile(sDefinitionFile);
        }

        public NWEffect EffectNWN2SpecialEffectFile(String sFileName, UInt32 oTarget, NWScript.Vector3 vTargetPosition)
        {
            return ScriptHost.ExecuteActionService_792_5_EffectNWN2SpecialEffectFile(sFileName, oTarget, vTargetPosition.z, vTargetPosition.y, vTargetPosition.x);
        }

        public Int32 GetSpellLevel(Int32 nSpellID)
        {
            return ScriptHost.ExecuteActionService_793_1_GetSpellLevel(nSpellID);
        }

        public void RemoveSEFFromObject(UInt32 oObject, String sSEFName)
        {
            ScriptHost.ExecuteActionService_794_2_RemoveSEFFromObject(oObject, sSEFName);
        }

        public void ActionPauseCutscene(Int32 nTimeoutSecs, Int32 bPurgeCutsceneActionsOnTimeout)
        {
            ScriptHost.ExecuteActionService_795_2_ActionPauseCutscene(nTimeoutSecs, bPurgeCutsceneActionsOnTimeout);
        }

        public void AssignCutsceneActionToObject(UInt32 oObject, NWAction aAction)
        {
            InternalSaveStateForAction(aAction);
            ScriptHost.ExecuteActionService_796_1_AssignCutsceneActionToObject(oObject);
        }

        public Int32 GetCharBackground(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_797_1_GetCharBackground(oCreature);
        }

        public void SetTrapActive(UInt32 oTrap, Int32 bActive)
        {
            ScriptHost.ExecuteActionService_798_2_SetTrapActive(oTrap, bActive);
        }

        public void SetOrientOnDialog(UInt32 oCreature, Int32 bActive)
        {
            ScriptHost.ExecuteActionService_799_2_SetOrientOnDialog(oCreature, bActive);
        }

        public NWEffect EffectDetectUndead()
        {
            return ScriptHost.ExecuteActionService_800_0_EffectDetectUndead();
        }

        public NWEffect EffectLowLightVision()
        {
            return ScriptHost.ExecuteActionService_801_0_EffectLowLightVision();
        }

        public NWEffect EffectSetScale(float fScaleX, float fScaleY, float fScaleZ)
        {
            return ScriptHost.ExecuteActionService_802_3_EffectSetScale((Single)fScaleX, (Single)fScaleY, (Single)fScaleZ);
        }

        public NWEffect EffectShareDamage(UInt32 oHelper, Int32 nAmtShared, Int32 nAmtCasterShared)
        {
            return ScriptHost.ExecuteActionService_803_3_EffectShareDamage(oHelper, nAmtShared, nAmtCasterShared);
        }

        public NWEffect EffectAssayResistance(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_804_1_EffectAssayResistance(oTarget);
        }

        public NWEffect EffectSeeTrueHPs()
        {
            return ScriptHost.ExecuteActionService_805_0_EffectSeeTrueHPs();
        }

        public Int32 GetNumCutsceneActionsPending()
        {
            return ScriptHost.ExecuteActionService_806_0_GetNumCutsceneActionsPending();
        }

        public NWEffect EffectDamageOverTime(Int32 nAmount, float fIntervalSeconds, Int32 nDamageType, Int32 nIgnoreResistances)
        {
            return ScriptHost.ExecuteActionService_807_4_EffectDamageOverTime(nAmount, (Single)fIntervalSeconds, nDamageType, nIgnoreResistances);
        }

        public NWEffect EffectAbsorbDamage(Int32 nACTest)
        {
            return ScriptHost.ExecuteActionService_808_1_EffectAbsorbDamage(nACTest);
        }

        public NWEffect EffectHideousBlow(Int32 nMetamagic)
        {
            return ScriptHost.ExecuteActionService_809_1_EffectHideousBlow(nMetamagic);
        }

        public NWEffect EffectMesmerize(Int32 nBreakFlags, float fBreakDist)
        {
            return ScriptHost.ExecuteActionService_810_2_EffectMesmerize(nBreakFlags, (Single)fBreakDist);
        }

        public Int32 GetSpellFeatId()
        {
            return ScriptHost.ExecuteActionService_811_0_GetSpellFeatId();
        }

        public void SetFog(UInt32 oTarget, Int32 nFogType, Int32 nColor, float fFogStart, float fFogEnd, float fFarClipPlaneDistance)
        {
            ScriptHost.ExecuteActionService_812_6_SetFog(oTarget, nFogType, nColor, (Single)fFogStart, (Single)fFogEnd, (Single)fFarClipPlaneDistance);
        }

        public NWEffect EffectDarkVision()
        {
            return ScriptHost.ExecuteActionService_813_0_EffectDarkVision();
        }

        public void DebugPostString(UInt32 oTarget, String sMesg, Int32 nX, Int32 nY, float fDuration, Int32 nColor)
        {
            ScriptHost.ExecuteActionService_814_6_DebugPostString(oTarget, sMesg, nX, nY, (Single)fDuration, nColor);
        }

        public Int32 GetHasAnySpellEffect(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_815_1_GetHasAnySpellEffect(oObject);
        }

        public NWEffect EffectArmorCheckPenaltyIncrease(UInt32 oTarget, Int32 nPenaltyAmt)
        {
            return ScriptHost.ExecuteActionService_816_2_EffectArmorCheckPenaltyIncrease(oTarget, nPenaltyAmt);
        }

        public NWEffect EffectDisintegrate(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_817_1_EffectDisintegrate(oTarget);
        }

        public NWEffect EffectHealOnZeroHP(UInt32 oTarget, Int32 nDmgToHeal)
        {
            return ScriptHost.ExecuteActionService_818_2_EffectHealOnZeroHP(oTarget, nDmgToHeal);
        }

        public NWEffect EffectBreakEnchantment(Int32 nLevel)
        {
            return ScriptHost.ExecuteActionService_819_1_EffectBreakEnchantment(nLevel);
        }

        public UInt32 GetFirstEnteringPC()
        {
            return ScriptHost.ExecuteActionService_820_0_GetFirstEnteringPC();
        }

        public UInt32 GetNextEnteringPC()
        {
            return ScriptHost.ExecuteActionService_821_0_GetNextEnteringPC();
        }

        public Int32 AddRosterMemberByTemplate(String sRosterName, String sTemplate)
        {
            return ScriptHost.ExecuteActionService_822_2_AddRosterMemberByTemplate(sRosterName, sTemplate);
        }

        public Int32 AddRosterMemberByCharacter(String sRosterName, UInt32 oCharacter)
        {
            return ScriptHost.ExecuteActionService_823_2_AddRosterMemberByCharacter(sRosterName, oCharacter);
        }

        public Int32 RemoveRosterMember(String sRosterName)
        {
            return ScriptHost.ExecuteActionService_824_1_RemoveRosterMember(sRosterName);
        }

        public Int32 GetIsRosterMemberAvailable(String sRosterName)
        {
            return ScriptHost.ExecuteActionService_825_1_GetIsRosterMemberAvailable(sRosterName);
        }

        public Int32 GetIsRosterMemberSelectable(String sRosterName)
        {
            return ScriptHost.ExecuteActionService_826_1_GetIsRosterMemberSelectable(sRosterName);
        }

        public Int32 SetIsRosterMemberSelectable(String sRosterName, Int32 bSelectable)
        {
            return ScriptHost.ExecuteActionService_827_2_SetIsRosterMemberSelectable(sRosterName, bSelectable);
        }

        public UInt32 GetObjectFromRosterName(String sRosterName)
        {
            return ScriptHost.ExecuteActionService_828_1_GetObjectFromRosterName(sRosterName);
        }

        public String GetRosterNameFromObject(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_829_1_GetRosterNameFromObject(oCreature);
        }

        public UInt32 SpawnRosterMember(String sRosterName, NWLocation lLocation)
        {
            return ScriptHost.ExecuteActionService_830_2_SpawnRosterMember(sRosterName, lLocation);
        }

        public Int32 DespawnRosterMember(String sRosterName)
        {
            return ScriptHost.ExecuteActionService_831_1_DespawnRosterMember(sRosterName);
        }

        public Int32 AddRosterMemberToParty(String sRosterName, UInt32 oPC)
        {
            return ScriptHost.ExecuteActionService_832_2_AddRosterMemberToParty(sRosterName, oPC);
        }

        public void RemoveRosterMemberFromParty(String sRosterName, UInt32 oPC, Int32 bDespawnNPC)
        {
            ScriptHost.ExecuteActionService_833_3_RemoveRosterMemberFromParty(sRosterName, oPC, bDespawnNPC);
        }

        public String GetFirstRosterMember()
        {
            return ScriptHost.ExecuteActionService_834_0_GetFirstRosterMember();
        }

        public String GetNextRosterMember()
        {
            return ScriptHost.ExecuteActionService_835_0_GetNextRosterMember();
        }

        public void SpawnSpellProjectile(UInt32 oSource, UInt32 oTaget, NWLocation lSource, NWLocation lTarget, Int32 nSpellID, Int32 nProjectilePathType)
        {
            ScriptHost.ExecuteActionService_836_6_SpawnSpellProjectile(oSource, oTaget, lSource, lTarget, nSpellID, nProjectilePathType);
        }

        public void SpawnItemProjectile(UInt32 oSource, UInt32 oTaget, NWLocation lSource, NWLocation lTarget, Int32 nBaseItemID, Int32 nProjectilePathType, Int32 nAttackType, Int32 nDamageTypeFlag)
        {
            ScriptHost.ExecuteActionService_837_8_SpawnItemProjectile(oSource, oTaget, lSource, lTarget, nBaseItemID, nProjectilePathType, nAttackType, nDamageTypeFlag);
        }

        public Int32 GetIsOwnedByPlayer(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_838_1_GetIsOwnedByPlayer(oCreature);
        }

        public UInt32 SetOwnersControlledCompanion(UInt32 oCurrentCreature, UInt32 oTargetCreature)
        {
            return ScriptHost.ExecuteActionService_839_2_SetOwnersControlledCompanion(oCurrentCreature, oTargetCreature);
        }

        public void SetCreatureScriptsToSet(UInt32 oCreature, Int32 nScriptSet)
        {
            ScriptHost.ExecuteActionService_840_2_SetCreatureScriptsToSet(oCreature, nScriptSet);
        }

        public float GetProjectileTravelTime(NWLocation lSource, NWLocation lTarget, Int32 nProjectilePathType, Int32 nSpellID)
        {
            return ScriptHost.ExecuteActionService_841_4_GetProjectileTravelTime(lSource, lTarget, nProjectilePathType, nSpellID);
        }

        public void SetRosterNPCPartyLimit(Int32 nLimit)
        {
            ScriptHost.ExecuteActionService_842_1_SetRosterNPCPartyLimit(nLimit);
        }

        public Int32 GetRosterNPCPartyLimit()
        {
            return ScriptHost.ExecuteActionService_843_0_GetRosterNPCPartyLimit();
        }

        public Int32 SetIsRosterMemberCampaignNPC(String sRosterName, Int32 nCampaignNPC)
        {
            return ScriptHost.ExecuteActionService_844_2_SetIsRosterMemberCampaignNPC(sRosterName, nCampaignNPC);
        }

        public Int32 GetIsRosterMemberCampaignNPC(String sRosterName)
        {
            return ScriptHost.ExecuteActionService_845_1_GetIsRosterMemberCampaignNPC(sRosterName);
        }

        public Int32 GetIsRosterMember(UInt32 oMember)
        {
            return ScriptHost.ExecuteActionService_846_1_GetIsRosterMember(oMember);
        }

        public void ShowWorldMap(String sWorldMap, UInt32 oPlayer, String sTag)
        {
            ScriptHost.ExecuteActionService_847_3_ShowWorldMap(sWorldMap, oPlayer, sTag);
        }

        public void TriggerEncounter(UInt32 oEncounter, UInt32 oPlayer, Int32 iCRFlag, float fCR)
        {
            ScriptHost.ExecuteActionService_848_4_TriggerEncounter(oEncounter, oPlayer, iCRFlag, (Single)fCR);
        }

        public Int32 GetIsSinglePlayer()
        {
            return ScriptHost.ExecuteActionService_849_0_GetIsSinglePlayer();
        }

        public void DisplayGuiScreen(UInt32 oPlayer, String sScreenName, Int32 bModal, String sFileName, Int32 bOverrideOptions)
        {
            ScriptHost.ExecuteActionService_850_5_DisplayGuiScreen(oPlayer, sScreenName, bModal, sFileName, bOverrideOptions);
        }

        public NWEffect EffectOnDispel(float fDelay, NWAction aOnDispelEffect)
        {
            InternalSaveStateForAction(aOnDispelEffect);
            return ScriptHost.ExecuteActionService_851_1_EffectOnDispel((Single)fDelay);
        }

        public void LoadNewModule(String sModuleName, String sWaypoint)
        {
            ScriptHost.ExecuteActionService_852_2_LoadNewModule(sModuleName, sWaypoint);
        }

        public void SetScriptHidden(UInt32 oCreature, Int32 bHidden, Int32 bDisableUI)
        {
            ScriptHost.ExecuteActionService_853_3_SetScriptHidden(oCreature, bHidden, bDisableUI);
        }

        public void SetIsCompanionPossessionBlocked(UInt32 oCreature, Int32 bBlocked)
        {
            ScriptHost.ExecuteActionService_854_2_SetIsCompanionPossessionBlocked(oCreature, bBlocked);
        }

        public void SetEventHandler(UInt32 oObject, Int32 iEventID, String sScriptName)
        {
            ScriptHost.ExecuteActionService_855_3_SetEventHandler(oObject, iEventID, sScriptName);
        }

        public String GetEventHandler(UInt32 oObject, Int32 iEventID)
        {
            return ScriptHost.ExecuteActionService_856_2_GetEventHandler(oObject, iEventID);
        }

        public Int32 GetIsPartyTransition(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_857_1_GetIsPartyTransition(oObject);
        }

        public void JumpPartyToArea(UInt32 oPartyMember, UInt32 oDestination)
        {
            ScriptHost.ExecuteActionService_858_2_JumpPartyToArea(oPartyMember, oDestination);
        }

        public Int32 GetNumActions(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_859_1_GetNumActions(oObject);
        }

        public void DisplayMessageBox(UInt32 oPC, Int32 nMessageStrRef, String sMessage, String sOkCB, String sCancelCB, Int32 bShowCancel, String sScreenName, Int32 nOkStrRef, String sOkString, Int32 nCancelStrRef, String sCancelString)
        {
            ScriptHost.ExecuteActionService_860_11_DisplayMessageBox(oPC, nMessageStrRef, sMessage, sOkCB, sCancelCB, bShowCancel, sScreenName, nOkStrRef, sOkString, nCancelStrRef, sCancelString);
        }

        public Int32 StringCompare(String sString1, String sString2, Int32 nCaseSensitive)
        {
            return ScriptHost.ExecuteActionService_861_3_StringCompare(sString1, sString2, nCaseSensitive);
        }

        public Int32 CharToASCII(String sString)
        {
            return ScriptHost.ExecuteActionService_862_1_CharToASCII(sString);
        }

        public UInt32 GetOwnedCharacter(UInt32 oControlled)
        {
            return ScriptHost.ExecuteActionService_863_1_GetOwnedCharacter(oControlled);
        }

        public UInt32 GetControlledCharacter(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_864_1_GetControlledCharacter(oCreature);
        }

        public Int32 FeatAdd(UInt32 oCreature, Int32 iFeatId, Int32 bCheckRequirements, Int32 bFeedback, Int32 bNotice)
        {
            return ScriptHost.ExecuteActionService_865_5_FeatAdd(oCreature, iFeatId, bCheckRequirements, bFeedback, bNotice);
        }

        public void FeatRemove(UInt32 oCreature, Int32 iFeatIds)
        {
            ScriptHost.ExecuteActionService_866_2_FeatRemove(oCreature, iFeatIds);
        }

        public void SetCanTalkToNonPlayerOwnedCreatures(UInt32 oObject, Int32 bCanTalk)
        {
            ScriptHost.ExecuteActionService_867_2_SetCanTalkToNonPlayerOwnedCreatures(oObject, bCanTalk);
        }

        public Int32 GetCanTalkToNonPlayerOwnedCreatures(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_868_1_GetCanTalkToNonPlayerOwnedCreatures(oObject);
        }

        public void SetLevelUpPackage(UInt32 oCreature, Int32 nPackage)
        {
            ScriptHost.ExecuteActionService_869_2_SetLevelUpPackage(oCreature, nPackage);
        }

        public Int32 GetLevelUpPackage(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_870_1_GetLevelUpPackage(oCreature);
        }

        public void SetCombatOverrides(UInt32 oCreature, UInt32 oTarget, Int32 nOnHandAttacks, Int32 nOffHandAttacks, Int32 nAttackResult, Int32 nMinDamage, Int32 nMaxDamage, Int32 bSuppressBroadcastAOO, Int32 bSuppressMakeAOO, Int32 bIgnoreTargetReaction, Int32 bSuppressFeedbackText)
        {
            ScriptHost.ExecuteActionService_871_11_SetCombatOverrides(oCreature, oTarget, nOnHandAttacks, nOffHandAttacks, nAttackResult, nMinDamage, nMaxDamage, bSuppressBroadcastAOO, bSuppressMakeAOO, bIgnoreTargetReaction, bSuppressFeedbackText);
        }

        public void ClearCombatOverrides(UInt32 oCreature)
        {
            ScriptHost.ExecuteActionService_872_1_ClearCombatOverrides(oCreature);
        }

        public void ResetCreatureLevelForXP(UInt32 oTargetCreature, Int32 nExperience, Int32 bUseXPMods)
        {
            ScriptHost.ExecuteActionService_873_3_ResetCreatureLevelForXP(oTargetCreature, nExperience, bUseXPMods);
        }

        public NWLocation CalcPointAwayFromPoint(NWLocation lPoint, NWLocation lAwayFromPoint, float fDistance, float fAngularVariance, Int32 bComputeDistFromStart)
        {
            return ScriptHost.ExecuteActionService_874_5_CalcPointAwayFromPoint(lPoint, lAwayFromPoint, (Single)fDistance, (Single)fAngularVariance, bComputeDistFromStart);
        }

        public NWLocation CalcSafeLocation(UInt32 oCreature, NWLocation lTestPosition, float fSearchRadius, Int32 bWalkStraighLineRequired, Int32 bIgnoreTestPosition)
        {
            return ScriptHost.ExecuteActionService_875_5_CalcSafeLocation(oCreature, lTestPosition, (Single)fSearchRadius, bWalkStraighLineRequired, bIgnoreTestPosition);
        }

        public Int32 GetTotalLevels(UInt32 oCreature, Int32 bIncludeNegativeLevels)
        {
            return ScriptHost.ExecuteActionService_876_2_GetTotalLevels(oCreature, bIncludeNegativeLevels);
        }

        public void ResetFeatUses(UInt32 oCreature, Int32 nFeatID, Int32 bResetDailyUses, Int32 bResetLastUseTime)
        {
            ScriptHost.ExecuteActionService_877_4_ResetFeatUses(oCreature, nFeatID, bResetDailyUses, bResetLastUseTime);
        }

        public void SetNWN2Fog(UInt32 oTarget, Int32 nFogType, Int32 nColor, float fFogStart, float fFogEnd)
        {
            ScriptHost.ExecuteActionService_878_5_SetNWN2Fog(oTarget, nFogType, nColor, (Single)fFogStart, (Single)fFogEnd);
        }

        public void ResetNWN2Fog(UInt32 oTarget, Int32 nFogType)
        {
            ScriptHost.ExecuteActionService_879_2_ResetNWN2Fog(oTarget, nFogType);
        }

        public NWEffect EffectBonusHitpoints(Int32 nHitpoints)
        {
            return ScriptHost.ExecuteActionService_880_1_EffectBonusHitpoints(nHitpoints);
        }

        public void SetGUIObjectHidden(UInt32 oPlayer, String sScreenName, String sUIObjectName, Int32 bHidden)
        {
            ScriptHost.ExecuteActionService_881_4_SetGUIObjectHidden(oPlayer, sScreenName, sUIObjectName, bHidden);
        }

        public void CloseGUIScreen(UInt32 oPlayer, String sScreenName)
        {
            ScriptHost.ExecuteActionService_882_2_CloseGUIScreen(oPlayer, sScreenName);
        }

        public Int32 FiredFromPartyTransition()
        {
            return ScriptHost.ExecuteActionService_883_0_FiredFromPartyTransition();
        }

        public Int32 GetScriptHidden(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_884_1_GetScriptHidden(oObject);
        }

        public String GetNodeSpeaker()
        {
            return ScriptHost.ExecuteActionService_885_0_GetNodeSpeaker();
        }

        public void SetLocalGUIVariable(UInt32 oPlayer, String sScreenName, Int32 nVarIndex, String sVarValue)
        {
            ScriptHost.ExecuteActionService_886_4_SetLocalGUIVariable(oPlayer, sScreenName, nVarIndex, sVarValue);
        }

        public void SetGUIObjectDisabled(UInt32 oPlayer, String sScreenName, String sUIObjectName, Int32 bDisabled)
        {
            ScriptHost.ExecuteActionService_887_4_SetGUIObjectDisabled(oPlayer, sScreenName, sUIObjectName, bDisabled);
        }

        public void SetGUIObjectText(UInt32 oPlayer, String sScreenName, String sUIObjectName, Int32 nStrRef, String sText)
        {
            ScriptHost.ExecuteActionService_888_5_SetGUIObjectText(oPlayer, sScreenName, sUIObjectName, nStrRef, sText);
        }

        public Int32 GetIsCompanionPossessionBlocked(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_889_1_GetIsCompanionPossessionBlocked(oCreature);
        }

        public NWEffect EffectBardSongSinging(Int32 nSpellId)
        {
            return ScriptHost.ExecuteActionService_890_1_EffectBardSongSinging(nSpellId);
        }

        public NWEffect EffectJarring()
        {
            return ScriptHost.ExecuteActionService_891_0_EffectJarring();
        }

        public Int32 GetEffectInteger(NWEffect eTest, Int32 nIdx)
        {
            return ScriptHost.ExecuteActionService_892_2_GetEffectInteger(eTest, nIdx);
        }

        public void RefreshSpellEffectDurations(UInt32 oTarget, Int32 nSpellId, float fDuration)
        {
            ScriptHost.ExecuteActionService_893_3_RefreshSpellEffectDurations(oTarget, nSpellId, (Single)fDuration);
        }

        public NWEffect SetEffectSpellId(NWEffect eTest, Int32 nSpellId)
        {
            return ScriptHost.ExecuteActionService_894_2_SetEffectSpellId(eTest, nSpellId);
        }

        public NWEffect EffectBABMinimum(Int32 nBABMin)
        {
            return ScriptHost.ExecuteActionService_895_1_EffectBABMinimum(nBABMin);
        }

        public Int32 GetTRUEBaseAttackBonus(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_896_1_GetTRUEBaseAttackBonus(oTarget);
        }

        public void SetFirstName(UInt32 oTarget, String sFirstName)
        {
            ScriptHost.ExecuteActionService_897_2_SetFirstName(oTarget, sFirstName);
        }

        public void SetLastName(UInt32 oTarget, String sLastName)
        {
            ScriptHost.ExecuteActionService_898_2_SetLastName(oTarget, sLastName);
        }

        public void SetDescription(UInt32 oTarget, String sDescription)
        {
            ScriptHost.ExecuteActionService_899_2_SetDescription(oTarget, sDescription);
        }

        public String GetFirstName(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_900_1_GetFirstName(oTarget);
        }

        public String GetLastName(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_901_1_GetLastName(oTarget);
        }

        public String GetDescription(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_902_1_GetDescription(oTarget);
        }

        public Int32 IsInMultiplayerConversation(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_903_1_IsInMultiplayerConversation(oObject);
        }

        public Int32 PlayCustomAnimation(UInt32 oObject, String sAnimationName, Int32 nLooping, float fSpeed)
        {
            return ScriptHost.ExecuteActionService_904_4_PlayCustomAnimation(oObject, sAnimationName, nLooping, (Single)fSpeed);
        }

        public NWEffect EffectMaxDamage()
        {
            return ScriptHost.ExecuteActionService_905_0_EffectMaxDamage();
        }

        public void DisplayInputBox(UInt32 oPC, Int32 nMessageStrRef, String sMessage, String sOkCB, String sCancelCB, Int32 bShowCancel, String sScreenName, Int32 nOkStrRef, String sOkString, Int32 nCancelStrRef, String sCancelString, String sDefaultString, String sUnusedString)
        {
            ScriptHost.ExecuteActionService_906_13_DisplayInputBox(oPC, nMessageStrRef, sMessage, sOkCB, sCancelCB, bShowCancel, sScreenName, nOkStrRef, sOkString, nCancelStrRef, sCancelString, sDefaultString, sUnusedString);
        }

        public Int32 SetWeaponVisibility(UInt32 oObject, Int32 nVisibile, Int32 nType)
        {
            return ScriptHost.ExecuteActionService_907_3_SetWeaponVisibility(oObject, nVisibile, nType);
        }

        public void SetLookAtTarget(UInt32 oObject, NWScript.Vector3 vTarget, Int32 nType)
        {
            ScriptHost.ExecuteActionService_908_5_SetLookAtTarget(oObject, vTarget.z, vTarget.y, vTarget.x, nType);
        }

        public Int32 GetBumpState(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_909_1_GetBumpState(oCreature);
        }

        public void SetBumpState(UInt32 oCreature, Int32 nBumpState)
        {
            ScriptHost.ExecuteActionService_910_2_SetBumpState(oCreature, nBumpState);
        }

        public Int32 GetOnePartyMode()
        {
            return ScriptHost.ExecuteActionService_911_0_GetOnePartyMode();
        }

        public UInt32 GetPrimaryPlayer()
        {
            return ScriptHost.ExecuteActionService_912_0_GetPrimaryPlayer();
        }

        public NWEffect EffectArcaneSpellFailure(Int32 nPercent)
        {
            return ScriptHost.ExecuteActionService_913_1_EffectArcaneSpellFailure(nPercent);
        }

        public void SpawnBloodHit(UInt32 oCreature, Int32 bCriticalHit, UInt32 oAttacker)
        {
            ScriptHost.ExecuteActionService_914_3_SpawnBloodHit(oCreature, bCriticalHit, oAttacker);
        }

        public UInt32 GetFirstArea()
        {
            return ScriptHost.ExecuteActionService_915_0_GetFirstArea();
        }

        public UInt32 GetNextArea()
        {
            return ScriptHost.ExecuteActionService_916_0_GetNextArea();
        }

        public Int32 GetArmorRank(UInt32 oItem)
        {
            return ScriptHost.ExecuteActionService_917_1_GetArmorRank(oItem);
        }

        public Int32 GetWeaponType(UInt32 oItem)
        {
            return ScriptHost.ExecuteActionService_918_1_GetWeaponType(oItem);
        }

        public UInt32 GetPlayerCurrentTarget(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_919_1_GetPlayerCurrentTarget(oCreature);
        }

        public NWEffect EffectWildshape()
        {
            return ScriptHost.ExecuteActionService_920_0_EffectWildshape();
        }

        public Int32 GetEncumbranceState(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_921_1_GetEncumbranceState(oCreature);
        }

        public void PackCampaignDatabase(String sCampaignName)
        {
            ScriptHost.ExecuteActionService_922_1_PackCampaignDatabase(sCampaignName);
        }

        public void UnlinkDoor(UInt32 oDoor)
        {
            ScriptHost.ExecuteActionService_923_1_UnlinkDoor(oDoor);
        }

        public UInt32 GetPlayerCreatureExamineTarget(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_924_1_GetPlayerCreatureExamineTarget(oCreature);
        }

        public void Clear2DACache(String s2DAName)
        {
            ScriptHost.ExecuteActionService_925_1_Clear2DACache(s2DAName);
        }

        public Int32 NWNXGetInt(String sPlugin, String sFunction, String sParam1, Int32 nParam2)
        {
            return ScriptHost.ExecuteActionService_926_4_NWNXGetInt(sPlugin, sFunction, sParam1, nParam2);
        }

        public float NWNXGetFloat(String sPlugin, String sFunction, String sParam1, Int32 nParam2)
        {
            return ScriptHost.ExecuteActionService_927_4_NWNXGetFloat(sPlugin, sFunction, sParam1, nParam2);
        }

        public String NWNXGetString(String sPlugin, String sFunction, String sParam1, Int32 nParam2)
        {
            return ScriptHost.ExecuteActionService_928_4_NWNXGetString(sPlugin, sFunction, sParam1, nParam2);
        }

        public void NWNXSetInt(String sPlugin, String sFunction, String sParam1, Int32 nParam2, Int32 nValue)
        {
            ScriptHost.ExecuteActionService_929_5_NWNXSetInt(sPlugin, sFunction, sParam1, nParam2, nValue);
        }

        public void NWNXSetFloat(String sPlugin, String sFunction, String sParam1, Int32 nParam2, float fValue)
        {
            ScriptHost.ExecuteActionService_930_5_NWNXSetFloat(sPlugin, sFunction, sParam1, nParam2, (Single)fValue);
        }

        public void NWNXSetString(String sPlugin, String sFunction, String sParam1, Int32 nParam2, String sValue)
        {
            ScriptHost.ExecuteActionService_931_5_NWNXSetString(sPlugin, sFunction, sParam1, nParam2, sValue);
        }

        public NWEffect EffectEffectIcon(Int32 nEffectIconId)
        {
            return ScriptHost.ExecuteActionService_932_1_EffectEffectIcon(nEffectIconId);
        }

        public void SetGUIProgressBarPosition(UInt32 oPlayer, String sScreenName, String sUIObjectName, float fPosition)
        {
            ScriptHost.ExecuteActionService_933_4_SetGUIProgressBarPosition(oPlayer, sScreenName, sUIObjectName, (Single)fPosition);
        }

        public void SetGUITexture(UInt32 oPlayer, String sScreenName, String sUIObjectName, String sTexture)
        {
            ScriptHost.ExecuteActionService_934_4_SetGUITexture(oPlayer, sScreenName, sUIObjectName, sTexture);
        }

        public NWEffect EffectRescue(Int32 nSpellId)
        {
            return ScriptHost.ExecuteActionService_935_1_EffectRescue(nSpellId);
        }

        public UInt32 IntToObject(Int32 nInt)
        {
            return ScriptHost.ExecuteActionService_936_1_IntToObject(nInt);
        }

        public Int32 ObjectToInt(UInt32 oObj)
        {
            return ScriptHost.ExecuteActionService_937_1_ObjectToInt(oObj);
        }

        public UInt32 StringToObject(String sString)
        {
            return ScriptHost.ExecuteActionService_938_1_StringToObject(sString);
        }

        public Int32 GetIsSpirit(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_939_1_GetIsSpirit(oCreature);
        }

        public NWEffect EffectDetectSpirits()
        {
            return ScriptHost.ExecuteActionService_940_0_EffectDetectSpirits();
        }

        public NWEffect EffectDamageReductionNegated()
        {
            return ScriptHost.ExecuteActionService_941_0_EffectDamageReductionNegated();
        }

        public NWEffect EffectConcealmentNegated()
        {
            return ScriptHost.ExecuteActionService_942_0_EffectConcealmentNegated();
        }

        public Int32 GetInfiniteFlag(UInt32 oItem)
        {
            return ScriptHost.ExecuteActionService_943_1_GetInfiniteFlag(oItem);
        }

        public String GetKeyRequiredFeedbackMessage(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_944_1_GetKeyRequiredFeedbackMessage(oObject);
        }

        public void SetKeyRequiredFeedbackMessage(UInt32 oObject, String sFeedback)
        {
            ScriptHost.ExecuteActionService_945_2_SetKeyRequiredFeedbackMessage(oObject, sFeedback);
        }

        public void SetInfiniteFlag(UInt32 oItem, Int32 bInfinite)
        {
            ScriptHost.ExecuteActionService_946_2_SetInfiniteFlag(oItem, bInfinite);
        }

        public Int32 GetPickpocketableFlag(UInt32 oItem)
        {
            return ScriptHost.ExecuteActionService_947_1_GetPickpocketableFlag(oItem);
        }

        public void SetPickpocketableFlag(UInt32 oItem, Int32 bPickpocketable)
        {
            ScriptHost.ExecuteActionService_948_2_SetPickpocketableFlag(oItem, bPickpocketable);
        }

        public Int32 GetTrapActive(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_949_1_GetTrapActive(oObject);
        }

        public void SetWillSavingThrow(UInt32 oObject, Int32 nNewWillSave)
        {
            ScriptHost.ExecuteActionService_950_2_SetWillSavingThrow(oObject, nNewWillSave);
        }

        public void SetReflexSavingThrow(UInt32 oObject, Int32 nNewReflexSave)
        {
            ScriptHost.ExecuteActionService_951_2_SetReflexSavingThrow(oObject, nNewReflexSave);
        }

        public void SetFortitudeSavingThrow(UInt32 oObject, Int32 nNewFortSave)
        {
            ScriptHost.ExecuteActionService_952_2_SetFortitudeSavingThrow(oObject, nNewFortSave);
        }

        public void SetLockKeyRequired(UInt32 oObject, Int32 nKeyRequired)
        {
            ScriptHost.ExecuteActionService_953_2_SetLockKeyRequired(oObject, nKeyRequired);
        }

        public void SetLockKeyTag(UInt32 oObject, String sKeyTag)
        {
            ScriptHost.ExecuteActionService_954_2_SetLockKeyTag(oObject, sKeyTag);
        }

        public void SetLockLockDC(UInt32 oObject, Int32 nNewLockDC)
        {
            ScriptHost.ExecuteActionService_955_2_SetLockLockDC(oObject, nNewLockDC);
        }

        public void SetLockUnlockDC(UInt32 oObject, Int32 nNewLockDC)
        {
            ScriptHost.ExecuteActionService_956_2_SetLockUnlockDC(oObject, nNewLockDC);
        }

        public void SetLockLockable(UInt32 oObject, Int32 nLockable)
        {
            ScriptHost.ExecuteActionService_957_2_SetLockLockable(oObject, nLockable);
        }

        public void SetHardness(Int32 nHardness, UInt32 oObject)
        {
            ScriptHost.ExecuteActionService_958_2_SetHardness(nHardness, oObject);
        }

        public Int32 GetHardness(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_959_1_GetHardness(oObject);
        }

        public Int32 GetModuleXPScale()
        {
            return ScriptHost.ExecuteActionService_960_0_GetModuleXPScale();
        }

        public void SetModuleXPScale(Int32 nXPScale)
        {
            ScriptHost.ExecuteActionService_961_1_SetModuleXPScale(nXPScale);
        }

        public void SetTrapDetectable(UInt32 oTrap, Int32 nDetectable)
        {
            ScriptHost.ExecuteActionService_962_2_SetTrapDetectable(oTrap, nDetectable);
        }

        public void SetTrapDetectDC(UInt32 oTrap, Int32 nDetectDC)
        {
            ScriptHost.ExecuteActionService_963_2_SetTrapDetectDC(oTrap, nDetectDC);
        }

        public void SetTrapDisarmable(UInt32 oTrap, Int32 nDisarmable)
        {
            ScriptHost.ExecuteActionService_964_2_SetTrapDisarmable(oTrap, nDisarmable);
        }

        public void SetTrapDisarmDC(UInt32 oTrap, Int32 nDisarmDC)
        {
            ScriptHost.ExecuteActionService_965_2_SetTrapDisarmDC(oTrap, nDisarmDC);
        }

        public void SetTrapKeyTag(UInt32 oTrap, String sKeyTag)
        {
            ScriptHost.ExecuteActionService_966_2_SetTrapKeyTag(oTrap, sKeyTag);
        }

        public void SetTrapOneShot(UInt32 oTrap, Int32 nOneShot)
        {
            ScriptHost.ExecuteActionService_967_2_SetTrapOneShot(oTrap, nOneShot);
        }

        public UInt32 CreateTrapAtLocation(Int32 nTrapType, NWLocation lLocation, float fSize, String sTag, Int32 nFaction, String sOnDisarmScript, String sOnTrapTriggeredScript)
        {
            return ScriptHost.ExecuteActionService_968_7_CreateTrapAtLocation(nTrapType, lLocation, (Single)fSize, sTag, nFaction, sOnDisarmScript, sOnTrapTriggeredScript);
        }

        public void CreateTrapOnObject(Int32 nTrapType, UInt32 oObject, Int32 nFaction, String sOnDisarmScript, String sOnTrapTriggeredScript)
        {
            ScriptHost.ExecuteActionService_969_5_CreateTrapOnObject(nTrapType, oObject, nFaction, sOnDisarmScript, sOnTrapTriggeredScript);
        }

        public Int32 GetAreaSize(Int32 nAreaDimension, UInt32 oArea)
        {
            return ScriptHost.ExecuteActionService_970_2_GetAreaSize(nAreaDimension, oArea);
        }

        public Int32 GetTrapRecoverable(UInt32 oTrap)
        {
            return ScriptHost.ExecuteActionService_971_1_GetTrapRecoverable(oTrap);
        }

        public void SetTrapRecoverable(UInt32 oTrap, Int32 nRecoverable)
        {
            ScriptHost.ExecuteActionService_972_2_SetTrapRecoverable(oTrap, nRecoverable);
        }

        public void SetUseableFlag(UInt32 oPlaceable, Int32 nUseableFlag)
        {
            ScriptHost.ExecuteActionService_973_2_SetUseableFlag(oPlaceable, nUseableFlag);
        }

        public UInt32 GetPlaceableLastClickedBy()
        {
            return ScriptHost.ExecuteActionService_974_0_GetPlaceableLastClickedBy();
        }

        public void SetRenderWaterInArea(UInt32 oArea, Int32 bRender)
        {
            ScriptHost.ExecuteActionService_975_2_SetRenderWaterInArea(oArea, bRender);
        }

        public NWEffect EffectInsane()
        {
            return ScriptHost.ExecuteActionService_976_0_EffectInsane();
        }

        public void SetPlayerGUIHidden(UInt32 oPlayer, Int32 bHidden)
        {
            ScriptHost.ExecuteActionService_977_2_SetPlayerGUIHidden(oPlayer, bHidden);
        }

        public String GetSelectedMapPointTag()
        {
            return ScriptHost.ExecuteActionService_978_0_GetSelectedMapPointTag();
        }

        public void SetNoticeText(UInt32 oPlayer, String sText)
        {
            ScriptHost.ExecuteActionService_979_2_SetNoticeText(oPlayer, sText);
        }

        public void SetLightActive(UInt32 oLight, Int32 bActive)
        {
            ScriptHost.ExecuteActionService_980_2_SetLightActive(oLight, bActive);
        }

        public NWEffect EffectSummonCopy(UInt32 oSource, Int32 nVisualEffectId, float fDelaySeconds, String sNewTag, Int32 nNewHP, String sScript)
        {
            return ScriptHost.ExecuteActionService_981_6_EffectSummonCopy(oSource, nVisualEffectId, (Single)fDelaySeconds, sNewTag, nNewHP, sScript);
        }

        public Int32 GetPolymorphLocked(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_982_1_GetPolymorphLocked(oCreature);
        }

        public void SetSoundSet(UInt32 oCreature, Int32 nSoundSet)
        {
            ScriptHost.ExecuteActionService_983_2_SetSoundSet(oCreature, nSoundSet);
        }

        public void SetScale(UInt32 oObject, float fX, float fY, float fZ)
        {
            ScriptHost.ExecuteActionService_984_4_SetScale(oObject, (Single)fX, (Single)fY, (Single)fZ);
        }

        public float GetScale(UInt32 oObject, Int32 nAxis)
        {
            return ScriptHost.ExecuteActionService_985_2_GetScale(oObject, nAxis);
        }

        public Int32 GetNum2DARows(String s2DAName)
        {
            return ScriptHost.ExecuteActionService_986_1_GetNum2DARows(s2DAName);
        }

        public Int32 GetNum2DAColumns(String s2DAName)
        {
            return ScriptHost.ExecuteActionService_987_1_GetNum2DAColumns(s2DAName);
        }

        public void SetCustomHeartbeat(UInt32 oTarget, Int32 nMSeconds)
        {
            ScriptHost.ExecuteActionService_988_2_SetCustomHeartbeat(oTarget, nMSeconds);
        }

        public Int32 GetCustomHeartbeat(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_989_1_GetCustomHeartbeat(oTarget);
        }

        public void SetScrollBarRanges(UInt32 oPlayer, String sScreenName, String sScrollBarName, Int32 nMinSize, Int32 nMaxSize, Int32 nMinValue, Int32 nMaxValue)
        {
            ScriptHost.ExecuteActionService_990_7_SetScrollBarRanges(oPlayer, sScreenName, sScrollBarName, nMinSize, nMaxSize, nMinValue, nMaxValue);
        }

        public void ClearListBox(UInt32 oPlayer, String sScreenName, String sListBox)
        {
            ScriptHost.ExecuteActionService_991_3_ClearListBox(oPlayer, sScreenName, sListBox);
        }

        public void AddListBoxRow(UInt32 oPlayer, String sScreenName, String sListBox, String sRowName, String sTextFields, String sTextures, String sVariables, String sHideUnhide)
        {
            ScriptHost.ExecuteActionService_992_8_AddListBoxRow(oPlayer, sScreenName, sListBox, sRowName, sTextFields, sTextures, sVariables, sHideUnhide);
        }

        public void RemoveListBoxRow(UInt32 oPlayer, String sScreenName, String sListBox, String sRowName)
        {
            ScriptHost.ExecuteActionService_993_4_RemoveListBoxRow(oPlayer, sScreenName, sListBox, sRowName);
        }

        public Int32 GetItemPropActivation(UInt32 oItem)
        {
            return ScriptHost.ExecuteActionService_994_1_GetItemPropActivation(oItem);
        }

        public void SetItemPropActivation(UInt32 oItem, Int32 nPref)
        {
            ScriptHost.ExecuteActionService_995_2_SetItemPropActivation(oItem, nPref);
        }

        public void ModifyListBoxRow(UInt32 oPlayer, String sScreenName, String sListBox, String sRowName, String sTextFields, String sTextures, String sVariables, String sHideUnhide)
        {
            ScriptHost.ExecuteActionService_996_8_ModifyListBoxRow(oPlayer, sScreenName, sListBox, sRowName, sTextFields, sTextures, sVariables, sHideUnhide);
        }

        public void SetFactionLeader(UInt32 oNewLeader)
        {
            ScriptHost.ExecuteActionService_997_1_SetFactionLeader(oNewLeader);
        }

        public UInt32 GetFirstSubArea(UInt32 oArea, NWScript.Vector3 vPosition)
        {
            return ScriptHost.ExecuteActionService_998_4_GetFirstSubArea(oArea, vPosition.z, vPosition.y, vPosition.x);
        }

        public UInt32 GetNextSubArea(UInt32 oArea)
        {
            return ScriptHost.ExecuteActionService_999_1_GetNextSubArea(oArea);
        }

        public float GetMovementRateFactor(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_1000_1_GetMovementRateFactor(oCreature);
        }

        public void SetMovementRateFactor(UInt32 oCreature, float fFactor)
        {
            ScriptHost.ExecuteActionService_1001_2_SetMovementRateFactor(oCreature, (Single)fFactor);
        }

        public String GetBicFileName(UInt32 oPC)
        {
            return ScriptHost.ExecuteActionService_1002_1_GetBicFileName(oPC);
        }

        public Int32 GetCollision(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_1003_1_GetCollision(oTarget);
        }

        public void SetCollision(UInt32 oTarget, Int32 bCollision)
        {
            ScriptHost.ExecuteActionService_1004_2_SetCollision(oTarget, bCollision);
        }

        public Int32 GetItemIcon(UInt32 oTarget)
        {
            return ScriptHost.ExecuteActionService_1005_1_GetItemIcon(oTarget);
        }

        public String GetVariableName(UInt32 oTarget, Int32 nPosition)
        {
            return ScriptHost.ExecuteActionService_1006_2_GetVariableName(oTarget, nPosition);
        }

        public Int32 GetVariableType(UInt32 oTarget, Int32 nPosition)
        {
            return ScriptHost.ExecuteActionService_1007_2_GetVariableType(oTarget, nPosition);
        }

        public Int32 GetAreaOfEffectDuration(UInt32 oAreaOfEffectObject)
        {
            return ScriptHost.ExecuteActionService_1008_1_GetAreaOfEffectDuration(oAreaOfEffectObject);
        }

        public Int32 GetIsPlayerCreated(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_1009_1_GetIsPlayerCreated(oCreature);
        }

        public String GetPartyName()
        {
            return ScriptHost.ExecuteActionService_1010_0_GetPartyName();
        }

        public String GetPartyMotto()
        {
            return ScriptHost.ExecuteActionService_1011_0_GetPartyMotto();
        }

        public Int32 GetIsOverlandMap(UInt32 oArea)
        {
            return ScriptHost.ExecuteActionService_1012_1_GetIsOverlandMap(oArea);
        }

        public Int32 SetUnrestrictedLevelUp(UInt32 oCreature)
        {
            return ScriptHost.ExecuteActionService_1013_1_SetUnrestrictedLevelUp(oCreature);
        }

        public Int32 GetSoundFileDuration(String sSoundFile)
        {
            return ScriptHost.ExecuteActionService_1014_1_GetSoundFileDuration(sSoundFile);
        }

        public Int32 GetPartyMembersDyingFlag()
        {
            return ScriptHost.ExecuteActionService_1015_0_GetPartyMembersDyingFlag();
        }

        public void SetListBoxRowSelected(UInt32 oPlayer, String sScreenName, String sListBox, String sRowName)
        {
            ScriptHost.ExecuteActionService_1016_4_SetListBoxRowSelected(oPlayer, sScreenName, sListBox, sRowName);
        }

        public Int32 GetTalkTableLanguage()
        {
            return ScriptHost.ExecuteActionService_1017_0_GetTalkTableLanguage();
        }

        public void SetScrollBarValue(UInt32 oPlayer, String sScreenName, String sScrollBarName, Int32 nValue)
        {
            ScriptHost.ExecuteActionService_1018_4_SetScrollBarValue(oPlayer, sScreenName, sScrollBarName, nValue);
        }

        public void SetPause(Int32 bState)
        {
            ScriptHost.ExecuteActionService_1019_1_SetPause(bState);
        }

        public Int32 GetPause()
        {
            return ScriptHost.ExecuteActionService_1020_0_GetPause();
        }

        public Int32 GetAreaOfEffectSpellId(UInt32 oAreaOfEffectObject)
        {
            return ScriptHost.ExecuteActionService_1021_1_GetAreaOfEffectSpellId(oAreaOfEffectObject);
        }

        public void SetGlobalGUIVariable(UInt32 oPlayer, Int32 nVarIndex, String sVarValue)
        {
            ScriptHost.ExecuteActionService_1022_3_SetGlobalGUIVariable(oPlayer, nVarIndex, sVarValue);
        }

        public UInt32 CreateInstancedAreaFromSource(UInt32 oArea)
        {
            return ScriptHost.ExecuteActionService_1023_1_CreateInstancedAreaFromSource(oArea);
        }

        public Int32 GetVariableValueInt(UInt32 oObject, Int32 nIndex)
        {
            return ScriptHost.ExecuteActionService_1024_2_GetVariableValueInt(oObject, nIndex);
        }

        public String GetVariableValueString(UInt32 oObject, Int32 nIndex)
        {
            return ScriptHost.ExecuteActionService_1025_2_GetVariableValueString(oObject, nIndex);
        }

        public float GetVariableValueFloat(UInt32 oObject, Int32 nIndex)
        {
            return ScriptHost.ExecuteActionService_1026_2_GetVariableValueFloat(oObject, nIndex);
        }

        public NWLocation GetVariableValueLocation(UInt32 oObject, Int32 nIndex)
        {
            return ScriptHost.ExecuteActionService_1027_2_GetVariableValueLocation(oObject, nIndex);
        }

        public UInt32 GetVariableValueObject(UInt32 oObject, Int32 nIndex)
        {
            return ScriptHost.ExecuteActionService_1028_2_GetVariableValueObject(oObject, nIndex);
        }

        public Int32 GetVariableCount(UInt32 oObject)
        {
            return ScriptHost.ExecuteActionService_1029_1_GetVariableCount(oObject);
        }

        public void SetBaseAbilityScore(UInt32 oCreature, Int32 nAbilityType, Int32 nScore)
        {
            ScriptHost.ExecuteActionService_1030_3_SetBaseAbilityScore(oCreature, nAbilityType, nScore);
        }

        public void SetBaseSkillRank(UInt32 oCreature, Int32 nSkill, Int32 nRank, Int32 bTrackWithLevel)
        {
            ScriptHost.ExecuteActionService_1031_4_SetBaseSkillRank(oCreature, nSkill, nRank, bTrackWithLevel);
        }

        public void SendChatMessage(UInt32 oSender, UInt32 oReceiver, Int32 nChannel, String sMessage, Int32 bInvokeCallback)
        {
            ScriptHost.ExecuteActionService_1032_5_SendChatMessage(oSender, oReceiver, nChannel, sMessage, bInvokeCallback);
        }

        public Int32 GetIsLocationValid(NWLocation lLocation)
        {
            return ScriptHost.ExecuteActionService_1033_1_GetIsLocationValid(lLocation);
        }

        public Int32 GetSurfaceMaterialsAtLocation(NWLocation lLocation)
        {
            return ScriptHost.ExecuteActionService_1034_1_GetSurfaceMaterialsAtLocation(lLocation);
        }

        public Int32 GetSpellKnown(UInt32 oCreature, Int32 nSpell)
        {
            return ScriptHost.ExecuteActionService_1035_2_GetSpellKnown(oCreature, nSpell);
        }

        public Int32 GetItemBaseMaterialType(UInt32 oItem)
        {
            return ScriptHost.ExecuteActionService_1036_1_GetItemBaseMaterialType(oItem);
        }

        public void SetItemBaseMaterialType(UInt32 oItem, Int32 nMaterialType)
        {
            ScriptHost.ExecuteActionService_1037_2_SetItemBaseMaterialType(oItem, nMaterialType);
        }

        public void SetSpellKnown(UInt32 oCreature, Int32 nClassPosition, Int32 nSpell, Int32 bKnown, Int32 bTrackWithLevel)
        {
            ScriptHost.ExecuteActionService_1038_5_SetSpellKnown(oCreature, nClassPosition, nSpell, bKnown, bTrackWithLevel);
        }

        public Int32 GetLimboCreatureCount()
        {
            return ScriptHost.ExecuteActionService_1039_0_GetLimboCreatureCount();
        }

        public UInt32 GetCreatureInLimbo(Int32 nTh)
        {
            return ScriptHost.ExecuteActionService_1040_1_GetCreatureInLimbo(nTh);
        }

        public void SendCreatureToLimbo(UInt32 oCreature)
        {
            ScriptHost.ExecuteActionService_1041_1_SendCreatureToLimbo(oCreature);
        }

        public void AddScriptParameterInt(Int32 nParam)
        {
            ScriptHost.ExecuteActionService_1042_1_AddScriptParameterInt(nParam);
        }

        public void AddScriptParameterString(String sParam)
        {
            ScriptHost.ExecuteActionService_1043_1_AddScriptParameterString(sParam);
        }

        public void AddScriptParameterFloat(float fParam)
        {
            ScriptHost.ExecuteActionService_1044_1_AddScriptParameterFloat((Single)fParam);
        }

        public void AddScriptParameterObject(UInt32 oParam)
        {
            ScriptHost.ExecuteActionService_1045_1_AddScriptParameterObject(oParam);
        }

        public Int32 ExecuteScriptEnhanced(String sScript, UInt32 oTarget, Int32 bClearParams)
        {
            return ScriptHost.ExecuteActionService_1046_3_ExecuteScriptEnhanced(sScript, oTarget, bClearParams);
        }

        public void ClearScriptParams()
        {
            ScriptHost.ExecuteActionService_1047_0_ClearScriptParams();
        }

        public void SetSkillPointsRemaining(UInt32 oPC, Int32 nPoints)
        {
            ScriptHost.ExecuteActionService_1048_2_SetSkillPointsRemaining(oPC, nPoints);
        }

        public Int32 GetSkillPointsRemaining(UInt32 oPC)
        {
            return ScriptHost.ExecuteActionService_1049_1_GetSkillPointsRemaining(oPC);
        }

        public Int32 GetCasterClassSpellSchool(UInt32 oPC, Int32 nClassPos)
        {
            return ScriptHost.ExecuteActionService_1050_2_GetCasterClassSpellSchool(oPC, nClassPos);
        }

        public void SetGender(UInt32 oCreature, Int32 nGender)
        {
            ScriptHost.ExecuteActionService_1051_2_SetGender(oCreature, nGender);
        }

        public void SetTag(UInt32 oObject, String sNewTag)
        {
            ScriptHost.ExecuteActionService_1052_2_SetTag(oObject, sNewTag);
        }

        public Int32 GetArmorRulesType(UInt32 oItem)
        {
            return ScriptHost.ExecuteActionService_1053_1_GetArmorRulesType(oItem);
        }

        public void SetArmorRulesType(UInt32 oItem, Int32 nType)
        {
            ScriptHost.ExecuteActionService_1054_2_SetArmorRulesType(oItem, nType);
        }

        public void SetItemIcon(UInt32 oItem, Int32 nIcon)
        {
            ScriptHost.ExecuteActionService_1055_2_SetItemIcon(oItem, nIcon);
        }

        public UInt32 GetObjectByTagAndType(String sTag, Int32 nObjectType, Int32 nTh)
        {
            return ScriptHost.ExecuteActionService_1056_3_GetObjectByTagAndType(sTag, nObjectType, nTh);
        }

        public void RecallCreatureFromLimboToLocation(UInt32 oCreature, NWLocation loc)
        {
            ScriptHost.ExecuteActionService_1057_2_RecallCreatureFromLimboToLocation(oCreature, loc);
        }


        //
        // End action service handler wrappers (autogenerated).
        //


    }
}
